"use strict";
(self["webpackChunkruntime"] = self["webpackChunkruntime"] || []).push([["ts_formula_ts"],{

/***/ "./ts/formula.ts":
/*!***********************!*\
  !*** ./ts/formula.ts ***!
  \***********************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "addFormattedFormula": () => (/* binding */ addFormattedFormula),
/* harmony export */   "escapeDot": () => (/* binding */ escapeDot),
/* harmony export */   "escapeRegExp": () => (/* binding */ escapeRegExp),
/* harmony export */   "formatExpression": () => (/* binding */ formatExpression),
/* harmony export */   "getFormulaAccountIDs": () => (/* binding */ getFormulaAccountIDs),
/* harmony export */   "getFormulaDims": () => (/* binding */ getFormulaDims),
/* harmony export */   "getIDbyCode": () => (/* binding */ getIDbyCode),
/* harmony export */   "getOnlyIDbyCode": () => (/* binding */ getOnlyIDbyCode),
/* harmony export */   "getRefDims": () => (/* binding */ getRefDims),
/* harmony export */   "parseFormula": () => (/* binding */ parseFormula)
/* harmony export */ });
/* harmony import */ var _tsutils__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./tsutils */ "./ts/tsutils.ts");

function getRefDims(formulaDims, formula) {
    var result = [];
    for (var i = 0; i < formulaDims.length; i++) {
        var sFormula = formula;
        var dim = formulaDims[i].NAME;
        if (sFormula.search(new RegExp(dim, "i")) !== -1) {
            result.push(dim.substring(0, dim.length - 1));
        }
    }
    return result;
}
function getFormulaDims(dimensions, allgattributes, type) {
    if (type === void 0) { type = "account"; }
    var list = [{ NAME: 'account.', MDX: '[Account].[Account].' },
        { NAME: 'version.', MDX: '[Version].[Version].' },
        { NAME: 'level.', MDX: '[Level].[Level].' },
        { NAME: 'measures.', MDX: '[Measures].' },
        { NAME: 'time.', MDX: '[Time].[Time].' }];
    list.push({ NAME: 'measure.', MDX: '[Measure].[Measure].' });
    if (dimensions) {
        for (var i = 0; i < dimensions.length; i++) {
            var id = dimensions[i].ID;
            var name_1 = id + '.';
            var mdx = '[' + id + '].[' + id + '].';
            list.push({ NAME: name_1, MDX: mdx });
        }
    }
    if (allgattributes) {
        for (var i = 0; i < allgattributes.length; i++) {
            var id = allgattributes[i].ID;
            var name_2 = id + '.';
            var mdx = '[' + id + '].[' + id + '].';
            list.push({ NAME: name_2, MDX: mdx });
        }
    }
    return list;
}
function getIDbyCode(code, dim, dimValues, initBalanceAccounts, type) {
    if (type === void 0) { type = "account"; }
    if (code.toLowerCase() === 'current' || code.toLowerCase() === 'currentmember')
        return 'CurrentMember';
    if (code.toLowerCase() === 'currentproperty')
        return '&[CurrentProperty]';
    if (code.toLowerCase() === 'prevmember')
        return 'PrevMember';
    if (code.toLowerCase() === 'nextmember')
        return 'NextMember';
    if (code.toLowerCase() === 'Parent')
        return 'Parent';
    if (code.toLowerCase() === 'FirstChild')
        return 'FirstChild';
    if (code.toLowerCase() === 'LastChild')
        return 'LastChild';
    if (code.toLowerCase() === 'year' || code.toLowerCase() === 'month' || code.toLowerCase() === 'quarter')
        return '[' + code.toUpperCase() + ']';
    if (code.toLowerCase() === 'amount')
        return '[Amount]';
    if (dim.toLowerCase() === type) {
        if (dimValues[type].length > 0) {
            for (var i = 0; i < dimValues[type].length; i++) {
                if (dimValues[type][i].CODE === code) {
                    return '&[' + dimValues[type][i].ID + ']';
                }
            }
        }
        if (initBalanceAccounts.length > 0) {
            for (var i = 0; i < initBalanceAccounts.length; i++) {
                if (initBalanceAccounts[i].CODE === code) {
                    return '&[' + initBalanceAccounts[i].ID + ']';
                }
            }
        }
    }
    else if (dim.toLowerCase() === 'time') {
        if (typeof code === 'string') {
            if (code.match(/^\d{6}$/))
                return "&[".concat(code.substring(0, 4), "-").concat(code.substring(4, 6), "]");
            else if (code.match(/^\d{4}-\d{2}$/))
                return "&[".concat(code, "]");
            else if (code.match(/^\d{4}$/))
                return "[YEAR].[".concat(code, "]");
            else if (code.match(/^\d{4}Q\d{1}$/))
                return "[QUARTER].[".concat(code.substring(0, 4), "-").concat(code.substring(4, 6), "]");
            else if (code.match(/^\$(.)*\$$/))
                return "&[".concat(code, "]");
            else
                return null;
        }
    }
    else {
        if (!dimValues[dim])
            return null;
        var codeField_1 = (dim === "version" ? "NAME" : "CODE");
        var val = dimValues[dim].find(function (d) { return d[codeField_1].toLowerCase() === code.toLowerCase() || d.RESULT_NODE == code; });
        if (val) {
            return '&[' + val.RESULT_NODE + ']';
        }
        else {
            return null;
        }
    }
    return null;
}
function getOnlyIDbyCode(code, dim, dimValues) {
    var val = dimValues[dim].find(function (d) { return d.CODE.toLowerCase() === code.toLowerCase() || d.RESULT_NODE == code; });
    if (val) {
        return val.RESULT_NODE;
    }
    else {
        return null;
    }
}
function escapeDot(dim) {
    if (dim.endsWith('.'))
        return dim.substring(0, dim.length - 1) + '\\.';
    return dim;
}
function parseFormula(sInFormula, dimensions, allgattributes, nameSets) {
    var sMdxFormula = sInFormula;
    var formularDims = getFormulaDims(dimensions, allgattributes);
    for (var i = 0; i < formularDims.length; i++) {
        var sFormula = sInFormula;
        var dim = formularDims[i].NAME;
        var dimMdx = formularDims[i].MDX;
        var _loop_1 = function () {
            var start = sFormula.search(escapeDot(dim));
            //if(start>0) sMdxFormula += sFormula.substring(0,start);
            var temp = sFormula.substring(start + dim.length);
            var end = void 0;
            if (temp.substring(0, 2) === '-1') {
                end = 2;
            }
            else {
                end = temp.search(/[^0-9a-zA-Z_]/);
            }
            var code = end === -1 ? temp : temp.substring(0, end);
            var nameSet = null;
            if (nameSets && nameSets.length > 0 && dim === 'time.') {
                //check nameSet member on time
                nameSet = nameSets.find(function (ns) { return ns.NAME === code && ns.DIMENSION === 'Time' && ns.TYPE === 'MEMBER'; });
            }
            if (nameSet) {
                sMdxFormula = sMdxFormula.replace(dim + code, "[Time].[".concat(code, "]"));
            }
            else if (dim !== 'version.') {
                var id = getIDbyCode(code, dim.substring(0, dim.length - 1), {}, []);
                if (id) {
                    sMdxFormula = sMdxFormula.replace(dim + code, dimMdx + id);
                }
                else {
                    console.log("code does not exist:" + code);
                    throw new SyntaxError(code + " ");
                }
            }
            sFormula = end === -1 ? '' : temp.substring(end);
        };
        while (sFormula.search(escapeDot(dim)) !== -1) {
            _loop_1();
        }
    }
    return sMdxFormula;
}
// function getAccountNamebyCode(accounts:any[], code:string){
//     let ac = accounts.find(a=>a.CODE===code);
//     if(ac) return ac.NAME;
//     else return 'UNKNOWN';
// }
/**
 * add FORMATTED_FORMULAR to accounts
 * @param accounts
 * @return {*}
 */
function addFormattedFormula(accounts) {
    var accountMap = (0,_tsutils__WEBPACK_IMPORTED_MODULE_0__.getStore)().getters.accountCodeMap;
    for (var i = 0; i < accounts.length; i++) {
        var acctObj = accountMap[accounts[i].CODE];
        if (!acctObj)
            continue;
        var sFormula = accounts[i].FORMULAR;
        var sNameFormula = sFormula;
        var dim = 'account.';
        if (!sFormula) {
            acctObj.FORMATTED_FORMULAR = null;
            continue;
        }
        while (sFormula.search(escapeDot(dim)) !== -1) {
            var start = sFormula.search(escapeDot(dim));
            var temp = sFormula.substring(start + dim.length);
            var end = void 0;
            if (temp.substring(0, 2) === '-1') {
                end = 2;
            }
            else {
                end = temp.search(/[^0-9a-zA-Z_]/);
            }
            var code = end === -1 ? temp : temp.substring(0, end);
            //let id = getAccountNamebyCode(accounts, code);
            var id = accountMap[code] ? accountMap[code].NAME : "UNKNOWN";
            sNameFormula = sNameFormula.replace(dim + code, dim + id);
            sFormula = end === -1 ? '' : temp.substring(end);
        }
        acctObj.FORMATTED_FORMULAR = sNameFormula;
    }
}
/**
 * get account IDs from MDX Formular
 * @param mdx MDX_FORMULAR from account
 * @return {*}
 */
function getFormulaAccountIDs(mdxFormular) {
    var accountIDs = [];
    var sFormula = mdxFormular;
    if (!sFormula)
        return null;
    sFormula = sFormula.replace(new RegExp(escapeRegExp("[Account].[Account]."), 'g'), '');
    if (sFormula.includes("].[") || sFormula.includes("iif"))
        return null;
    sFormula = mdxFormular;
    var dim = '[Account].[Account].&[';
    while (sFormula.indexOf(dim) !== -1) {
        var start = sFormula.indexOf(dim);
        var temp = sFormula.substring(start + dim.length);
        var end = temp.search(/[^0-9a-zA-Z_]/);
        var id = end === -1 ? temp : temp.substring(0, end);
        if (id)
            accountIDs.push(id);
        sFormula = end === -1 ? '' : temp.substring(end);
    }
    var cast_array = Array;
    return cast_array.from(new Set(accountIDs));
}
function escapeRegExp(string) {
    return string.replace(/[.*+?^${}()|[\]\\]/g, '\\$&'); // $& means the whole matched string
}
function formatExpression(expression, colMap) {
    var sFormula = expression;
    var dim = 'data.';
    var from = 0;
    var cache = [];
    while (sFormula.indexOf(dim, from) !== -1) {
        var start = sFormula.indexOf(dim, from);
        var temp = sFormula.substring(start + dim.length);
        var end = temp.search(/[^0-9a-zA-Z_]/);
        var code = end === -1 ? temp : temp.substring(0, end);
        if (code && colMap[dim + code]) {
            cache.push({ index: start, key: dim + code });
        }
        from = end === -1 ? sFormula.length : start + dim.length + end;
    }
    for (var i = cache.length - 1; i >= 0; i--) {
        var ca = cache[i];
        sFormula = sFormula.substring(0, ca.index) + colMap[ca.key] + sFormula.substring(ca.index + ca.key.length);
    }
    return sFormula;
}



/***/ })

}]);
//# sourceMappingURL=ts_formula_ts.build.js.map