"use strict";
(self["webpackChunkruntime"] = self["webpackChunkruntime"] || []).push([["ts_runtime_ts"],{

/***/ "./ts/runtime.ts":
/*!***********************!*\
  !*** ./ts/runtime.ts ***!
  \***********************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "buildBlankSheet": () => (/* binding */ buildBlankSheet),
/* harmony export */   "buildSheetMeta": () => (/* binding */ buildSheetMeta),
/* harmony export */   "getBranches": () => (/* binding */ getBranches),
/* harmony export */   "getDatePeriod": () => (/* binding */ getDatePeriod),
/* harmony export */   "getDateRange": () => (/* binding */ getDateRange),
/* harmony export */   "passMDX": () => (/* binding */ passMDX)
/* harmony export */ });
/* harmony import */ var vue__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! vue */ "./node_modules/_vue@2.6.14@vue/dist/vue.common.dev.js");
/* harmony import */ var vue__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(vue__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _ts_tsutils__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../ts/tsutils */ "./ts/tsutils.ts");
/* provided dependency */ var $ = __webpack_require__(/*! jquery */ "./node_modules/_jquery@3.6.0@jquery/dist/jquery.min.js");

var VueApp = (vue__WEBPACK_IMPORTED_MODULE_0___default());
var objectAssign = __webpack_require__(/*! object-assign */ "./node_modules/_object-assign@4.1.1@object-assign/index.js");

var mdxUniNmRe = /\[.*\]\.\[.*\]\.\&\[(-?\d*)\]/;
function mdxRetrieveValue(originVal) {
    var match = mdxUniNmRe.exec(originVal);
    return (match ? match[1] : null);
}
var max_rows = 2000;
//const singleActualVersion = (sessionStorage.getItem('singleActualVersion')==='true');
var enableMeasure = (sessionStorage.enable_measure === "true");
var enableAsset = (sessionStorage.getItem("enable_asset") === "true");
var permissionStr = sessionStorage.getItem("permission");
var permissionObj = permissionStr ? JSON.parse(permissionStr) : null;
var fiscal_year_start = sessionStorage.getItem("fiscal_year_start");
var singleCurrency = sessionStorage.getItem("single_currency");
var enableDatalock = (sessionStorage.enable_datalock === "true");
function buildSheetMeta(param) {
    var sheetId = param.sheetId, extended = param.extended, isReport = param.isReport, forDesign = param.forDesign;
    var sheetModel = {
        id: sheetId,
        versions: [],
        defaultVersion: null,
        name: "",
        desc: "",
        dimList: [],
        dimMap: {},
        fieldList: [],
        fieldMap: {},
        kfList: [],
        kfMap: {},
        dfList: [],
        dfMap: {},
        relList: [],
        approvable: 0,
        //import_option: 1,
        editMode: false,
        permission: {},
        group: "",
        measures: [],
        enableDatalock: false,
    };
    var sheetDefURL = isReport === 2 ? '/hdb/getSheetMeta/freeSheet' :
        (isReport === 1 ? "/hdb/getSheetMeta/report/".concat(sheetId) : "/hdb/getSheetMeta/".concat(forDesign ? 'design/' : '').concat(sheetId));
    var extendedData = {};
    var extendedPromises = [];
    if (extended) {
        var allDimsPromise = $.post('/hdb/getDimensions', { action: 'getTables' }).then(function (data) {
            var tables = data || [];
            var dimName = "";
            var dim = null;
            var dimList = [];
            for (var i = 0; i < tables.length; i++) {
                var row = tables[i];
                if (dimName !== row.NAME) {
                    dim = {
                        ID: row.ID,
                        NAME: (row.NAME ? row.NAME : row.ID),
                        ishierarchy: !!(row.HAS_HIERARCHY),
                        values: []
                    };
                    dimList.push(dim);
                    dimName = row.NAME;
                }
            }
            extendedData.dimList = dimList;
        });
        extendedPromises.push(allDimsPromise);
        if (isReport === 0) {
            var snapshotPromise = $.getJSON("/hdb/sheetSnapshot/".concat(sheetId)).then(function (data) {
                extendedData.snapshots = data;
            });
            extendedPromises.push(snapshotPromise);
            var publicSSPromise = $.getJSON("/hdb/publicSnapshots/".concat(sheetId)).then(function (list) {
                for (var i = 0; i < list.length; i++) {
                    if (list[i].DEFAULT === 1) {
                        extendedData.defSnapshot = list[i];
                        return;
                    }
                }
                extendedData.defSnapshot = null;
                return;
            });
            extendedPromises.push(publicSSPromise);
        }
        if (enableDatalock) {
            var getDatalock = $.post('/hdb/dataLock', { action: 'getDataLockDims' }).then(function (data) {
                extendedData.dataLock = data;
                if (data.ifByUser) {
                    var getUser = $.post('/hdb/getUser', { action: 'getUser' }).then(function (data) {
                        extendedData.userList = data;
                    });
                    extendedPromises.push(getUser);
                }
            });
            extendedPromises.push(getDatalock);
        }
    }
    return new Promise(function (resolve, reject) {
        $.getJSON(sheetDefURL).done(function (sheetMeta) {
            if (!sheetMeta) {
                reject("Cannot load sheet meta data!");
                return;
            }
            var extraMetaPromises = [];
            sheetModel.name = sheetMeta.name;
            sheetModel.desc = sheetMeta.desc;
            sheetModel.group = sheetMeta.group;
            sheetModel.id = sheetId;
            sheetModel.approvable = !!sheetMeta.APPROVABLE;
            sheetModel.lock = !!sheetMeta.lock;
            if (sheetMeta.lock)
                sheetModel.lockReason = sheetMeta.lock.reason;
            sheetModel.permObj = sheetMeta.permObj;
            //sheetModel.import_option = !!sheetMeta.IMPORT_OPTION;
            sheetModel.versions = sheetMeta.versions;
            //sheetModel.defVerActual = false;
            if (sheetModel.versions && sheetModel.versions.length > 0) {
                for (var i = 0; i < sheetModel.versions.length; i++) {
                    if (sheetModel.versions[i].default) {
                        sheetModel.defaultVersion = sheetModel.versions[i].ID;
                        //sheetModel.defVerActual = (sheetModel.versions[i].VERSION_TYPE === "Actual");
                        break;
                    }
                }
            }
            sheetModel.dfList = sheetMeta.time;
            sheetModel.permission = sheetMeta.permission;
            if (!sheetModel.dfList || sheetModel.dfList.length === 0) {
                sheetModel.dfList = [
                    //{ID: "DATE", NAME: Vue.i18n.translate("timeunit.DATE")},
                    //{ID: "WEEK", NAME: Vue.i18n.translate("timeunit.WEEK")},
                    { ID: "MONTH", NAME: VueApp.i18n.translate("timeunit.MONTH") },
                    { ID: "QUARTER", NAME: VueApp.i18n.translate("timeunit.QUARTER") },
                    { ID: "YEAR", NAME: VueApp.i18n.translate("timeunit.YEAR") }
                ];
            }
            else {
                sheetModel.dfList.forEach(function (t) { return (t.NAME = VueApp.i18n.translate("timeunit." + t.ID)); });
                sheetModel.dfList.sort(function (a, b) {
                    var ia = (0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.getTimeLevel)(a.ID), ib = (0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.getTimeLevel)(b.ID);
                    return ib - ia;
                });
            }
            sheetModel.dfList.forEach(function (df) { return (sheetModel.dfMap[df.ID] = df); });
            sheetModel.kfList = sheetMeta.accounts;
            if (sheetModel.kfList)
                sheetModel.kfList.forEach(function (kf) { return (sheetModel.kfMap[kf.ID] = kf); });
            var dimObj = { ID: "ACCOUNT", NAME: VueApp.i18n.translate("account"), ishierarchy: true, fieldList: [], fieldMap: {} };
            var attrObj = { ID: "NAME", NAME: VueApp.i18n.translate("account"), DIM_ID: "ACCOUNT", ishierarchy: true, parent: dimObj };
            attrObj.values = sheetMeta.accounts;
            dimObj.fieldList.push(attrObj);
            dimObj.fieldMap = { "NAME": attrObj };
            //sheetModel.dimList.push(dimObj);
            sheetModel.dimMap["ACCOUNT"] = dimObj;
            //sheetModel.fieldList.push(attrObj);
            sheetModel.fieldMap["ACCOUNT_NAME"] = attrObj;
            dimObj = { ID: "LEVEL", NAME: VueApp.i18n.translate("organization"), ishierarchy: true, fieldList: [], fieldMap: {} };
            attrObj = { ID: "NAME", NAME: VueApp.i18n.translate("organization"), DIM_ID: "LEVEL", ishierarchy: true, parent: dimObj };
            attrObj.values = sheetMeta.levels;
            dimObj.fieldList.push(attrObj);
            dimObj.fieldMap = { "NAME": attrObj };
            sheetModel.dimList.push(dimObj);
            sheetModel.dimMap["LEVEL"] = dimObj;
            sheetModel.fieldList.push(attrObj);
            sheetModel.fieldMap["LEVEL_NAME"] = attrObj;
            if (enableMeasure) {
                sheetModel.dimMap["MEASURE"] = { ID: "MEASURE", NAME: VueApp.i18n.translate("measure"), ishierarchy: true };
            }
            sheetModel.levelBranchs = sheetMeta.levelBranchs;
            sheetModel.accountBranchs = sheetMeta.accountBranchs;
            var misc = sheetMeta.misc;
            if (misc) {
                sheetModel.inputOnly = misc.inputOnly;
                sheetModel.rowInput = misc.rowInput;
                sheetModel.allowInput = misc.allowInput;
                sheetModel.allDataFromSheet = misc.allDataFromSheet;
                sheetModel.sheetDataVersion = misc.sheetDataVersion;
                sheetModel.type = misc.type;
                if (!misc.type)
                    sheetModel.type = sheetModel.inputOnly ? 2 : 1;
                sheetModel.distDimension = misc.distDimension;
                sheetModel.distDimRoot = misc.distDimRoot;
                sheetModel.accountHierarchy = (misc.accountHierarchy === "default" ? null : misc.accountHierarchy);
                sheetModel.levelHierarchy = (misc.levelHierarchy === "default" ? null : misc.levelHierarchy);
                sheetModel.cube = misc.cube;
                sheetModel.styles = misc.styles;
                sheetModel.measureStyles = misc.measureStyles;
                sheetModel.ranges = misc.ranges;
                sheetModel.measureRanges = misc.measureRanges;
                sheetModel.disableDDAcct = misc.disableDDAcct;
                sheetModel.ddSettings = misc.ddSettings;
                if (misc.defaultVersion) {
                    sheetModel.defaultVersion = misc.defaultVersion;
                    //sheetModel.defVerActual = misc.defVerActual;
                }
                if (misc.measures && misc.measures.length === 1 && misc.measures[0].ID === -1)
                    misc.measures = null;
                if (misc.measures && misc.measures.length > 0) {
                    var measurePromise = Promise.resolve($.post({
                        url: '/hdb/getLeafs',
                        data: JSON.stringify({ table: "MEASURE", list: misc.measures.map(function (m) { return m.ID; }) /*, actual:true*/ }),
                        processData: true,
                        contentType: "application/json",
                        headers: {
                            "Accept": "application/json"
                        },
                    }).done(function (rawdata) {
                        var map = (0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.buildMapFromList)(misc.measures, "ID");
                        var measures = [];
                        var ratioCal = { totalMeasure: null, numMeasure: null, ratioMeasure: null, aggrTotalMeasure: null, aggrNumMeasure: null };
                        var hasTimeMeasure = false;
                        for (var i = 0; i < rawdata.length; i++) {
                            var r = rawdata[i];
                            var m = { ID: r.RESULT_NODE, CODE: r.CODE, NAME: r.NAME, RATIO_CALC: 0, DISPLAY_TYPE: r.DISPLAY_TYPE };
                            if (map[r.RESULT_NODE]) {
                                m.RATIO_CALC = parseInt(map[r.RESULT_NODE].RATIO_CALC) || 0;
                                if (m.RATIO_CALC === 1)
                                    ratioCal.totalMeasure = m;
                                else if (m.RATIO_CALC === 2)
                                    ratioCal.numMeasure = m;
                                else if (m.RATIO_CALC === 3)
                                    ratioCal.ratioMeasure = m;
                                else if (m.RATIO_CALC === 5)
                                    ratioCal.aggrTotalMeasure = m;
                                else if (m.RATIO_CALC === 6)
                                    ratioCal.aggrNumMeasure = m;
                            }
                            measures.push(m);
                            if (!hasTimeMeasure && r.FORMULAR_MDX && r.FORMULAR_MDX.match(/PeriodsToDate/i))
                                hasTimeMeasure = true;
                        }
                        sheetModel.measures = measures;
                        sheetModel.hasTimeMeasure = hasTimeMeasure;
                        if (ratioCal.totalMeasure && ratioCal.numMeasure && ratioCal.ratioMeasure)
                            sheetModel.ratioCal = ratioCal;
                    }));
                    extraMetaPromises.push(measurePromise);
                }
                sheetModel.useTablePerm = misc.useTablePerm;
                sheetModel.script = misc.script;
                sheetModel.autoExecute = misc.autoExecute;
            }
            else {
                sheetModel.inputOnly = false;
                sheetModel.rowInput = false;
                sheetModel.allowInput = false;
                sheetModel.allDataFromSheet = false;
                sheetModel.sheetDataVersion = 0;
                sheetModel.accountHierarchy = null;
                sheetModel.levelHierarchy = null;
                sheetModel.defaultVersion = null;
                sheetModel.type = 1;
                sheetModel.useTablePerm = false;
                sheetModel.script = null;
                sheetModel.autoExecute = false;
                //sheetModel.defVerActual = false;
            }
            sheetModel.inputDimList = [];
            var attributes = sheetMeta.rawAttributes;
            if (attributes.inputOnly)
                sheetModel.inputOnly = true;
            if (sheetModel.inputOnly || sheetModel.type === 3) {
                if (sheetModel.inputOnly) {
                    sheetModel.aggregateCol = attributes.aggregateCol;
                    sheetModel.aggregateRow = attributes.aggregateRow;
                    if (sheetModel.rowInput)
                        sheetModel.aggregateCol = false;
                    sheetModel.formularFixCol = attributes.formularFixCol;
                    sheetModel.formularFixRow = attributes.formularFixRow;
                    sheetModel.singleValCol = attributes.singleValCol;
                    sheetModel.rowDims = attributes.rowDims;
                    sheetModel.colDims = attributes.colDims;
                    sheetModel.filterDims = attributes.filterDims.filter(function (dim) { return (dim.code !== "DATE" && dim.code !== "ACCOUNT"); });
                }
                else {
                    sheetModel.rowDims = [{ code: sheetModel.distDimension, hierarchy: true, type: "dimension",
                            attributes: [{ code: "NAME", hierarchy: true, parent: sheetModel.distDimension, type: "attribute", values: [{ ID: sheetModel.distDimRoot }] }] }];
                    sheetModel.colDims = [{ code: "ACCOUNT", hierarchy: true, type: "dimension" }];
                    sheetModel.filterDims = attributes;
                }
                var allDims = [].concat(sheetModel.rowDims, sheetModel.colDims, sheetModel.filterDims);
                var filterIndex = sheetModel.rowDims.length + 1;
                sheetModel.attributes = [];
                var dateMandatory = true;
                var accountMandatory = true;
                var levelMandatory = true;
                var foundLevel = false;
                for (var i = 0; i < allDims.length; i++) {
                    var dim = allDims[i];
                    if (dim.code === "LEVEL") {
                        dimObj = sheetModel.dimMap["LEVEL"];
                        dimObj.dispAttrs = dim.dispAttrs;
                    }
                    else
                        dimObj = { ID: dim.code, NAME: dim.name, fieldList: [], fieldMap: {}, ishierarchy: dim.hierarchy, isRelationship: (dim.type === "relationship"), dispAttrs: dim.dispAttrs };
                    if (!foundLevel && dim.code === "LEVEL")
                        foundLevel = true;
                    if (dim.code !== "LEVEL" && dim.code !== "ACCOUNT" && dim.code !== "DATE") {
                        sheetModel.attributes.push(dim);
                        sheetModel.dimList.push(dimObj);
                        sheetModel.dimMap[dim.code] = dimObj;
                        if (dim.type !== "relationship") {
                            var nameAttr = dim.attributes[0];
                            attrObj = { ID: "NAME", NAME: dim.name, DIM_ID: dim.code, ishierarchy: dim.hierarchy, values: nameAttr.values, withDefaultFilter: (nameAttr.values && nameAttr.values.length > 0), parent: dimObj, hidden: nameAttr.hidden };
                            dimObj.fieldList.push(attrObj);
                            dimObj.fieldMap["NAME"] = attrObj;
                            sheetModel.fieldList.push(attrObj);
                            sheetModel.fieldMap[dim.code + "_NAME"] = attrObj;
                            sheetModel.inputDimList.push(dimObj);
                        }
                    }
                    if (i >= filterIndex || (sheetModel.singleValCol && i === filterIndex - 1)) {
                        var field = sheetModel.fieldMap[dim.code + "_NAME"];
                        if (field)
                            field.mandatory = true;
                    }
                    else {
                        if (dateMandatory && dim.code === "DATE")
                            dateMandatory = false;
                        if (accountMandatory && dim.code === "ACCOUNT")
                            accountMandatory = false;
                        if (levelMandatory && dim.code === "LEVEL")
                            levelMandatory = false;
                    }
                    if (dim.attributes && dim.attributes.length > 0) {
                        for (var j = 0; j < dim.attributes.length; j++) {
                            var attr = dim.attributes[j];
                            if (!attr.selected)
                                continue;
                            attrObj = { ID: attr.code, NAME: attr.name, DIM_ID: dim.code, tooltip: VueApp.i18n.translate("dim_attr_name", { dim: dim.name, attr: attr.name }), ishierarchy: attr.hierarchy, values: attr.values, withDefaultFilter: (attr.values && attr.values.length > 0), parent: dimObj, hidden: attr.hidden };
                            dimObj.fieldList.push(attrObj);
                            dimObj.fieldMap[attr.code] = attrObj;
                            sheetModel.fieldList.push(attrObj);
                            sheetModel.fieldMap[dim.code + "_" + attr.code] = attrObj;
                        }
                    }
                }
                if (!foundLevel)
                    sheetModel.filterDims.push({ code: "LEVEL", name: VueApp.i18n.translate("organization"), hierarchy: true });
                sheetModel.dateMandatory = dateMandatory;
                sheetModel.accountMandatory = accountMandatory;
                sheetModel.fieldMap["LEVEL_NAME"].mandatory = levelMandatory;
                sheetModel.relList = sheetModel.filterDims.filter(function (d) { return (d.type === "relationship"); });
            }
            else {
                sheetModel.attributes = attributes;
                if (attributes) {
                    for (var i = 0; i < attributes.length; i++) {
                        var dim = attributes[i];
                        if (dim.type === "relationship") {
                            sheetModel.relList.push(dim);
                            continue;
                        }
                        if (sheetModel.dimMap[dim.code]) {
                            dimObj = sheetModel.dimMap[dim.code];
                        }
                        else {
                            dimObj = { ID: dim.code, NAME: dim.name, fieldList: [], fieldMap: {}, ishierarchy: dim.hierarchy };
                            sheetModel.dimList.push(dimObj);
                            sheetModel.dimMap[dim.code] = dimObj;
                        }
                        for (var j = 0; j < dim.attributes.length; j++) {
                            var attr = dim.attributes[j];
                            attrObj = { ID: attr.code, NAME: (attr.code === "NAME" ? dim.name : attr.name), DIM_ID: dim.code, tooltip: (attr.code !== "NAME" ? VueApp.i18n.translate("dim_attr_name", { dim: dim.name, attr: attr.name }) : null), ishierarchy: attr.hierarchy, values: attr.values, withDefaultFilter: (attr.values && attr.values.length > 0), parent: dimObj, flagAttr: attr.flagAttr, flagAttrVal: attr.flagAttrVal, flagAttrName: attr.flagAttrName, flagAttrValName: attr.flagAttrValName, hidden: attr.hidden };
                            dimObj.fieldList.push(attrObj);
                            dimObj.fieldMap[attr.code] = attrObj;
                            sheetModel.fieldList.push(attrObj);
                            sheetModel.fieldMap[dim.code + "_" + attr.code] = attrObj;
                            if (attr.code === "NAME")
                                sheetModel.inputDimList.push(dimObj);
                        }
                    }
                }
            }
            if (sheetModel.relList && sheetModel.relList.length > 0) {
                var relationshipPromise = $.getJSON('/hdb/relationship').then(function (data) {
                    var relationships = [];
                    for (var i = 0; i < data.length; i++) {
                        var r = data[i];
                        var dim = {
                            code: r.ID,
                            dim1: r.DIM1,
                            dim2: r.DIM2,
                            dim3: r.DIM3,
                            thirdDim: (r.MORE_DIMS === 1),
                            inputOnly: (r.INPUT_ONLY === 1)
                            //allowValues:(r.VALUES?JSON.parse(r.VALUES):null)
                        };
                        relationships.push(dim);
                    }
                    var relMap = (0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.buildMapFromList)(relationships, 'code');
                    for (var i = 0; i < sheetModel.relList.length; i++) {
                        var rel = sheetModel.relList[i];
                        var relObj = relMap[rel.code];
                        if (relObj) { //match with newest relationship definition
                            rel.dim1 = relObj.dim1;
                            rel.dim2 = relObj.dim2;
                            rel.dim3 = relObj.dim3;
                            rel.thirdDim = relObj.thirdDim;
                            rel.inputOnly = relObj.inputOnly;
                        }
                        var dimIDs = [rel.dim1, rel.dim2];
                        for (var j = 0; j < 2; j++) {
                            var dimID = dimIDs[j];
                            if (sheetModel.dimMap[dimID]) {
                                var attrObj_1 = sheetModel.dimMap[dimID].fieldMap["NAME"];
                                if (!attrObj_1)
                                    continue;
                                if (!attrObj_1.relationships)
                                    attrObj_1.relationships = [];
                                attrObj_1.relationships.push(rel);
                            }
                        }
                    }
                    sheetModel.relQueryList = sheetModel.relList.filter(function (r) { return (!r.forEditable && !r.inputOnly); });
                }).catch(function (_) { return []; });
                extraMetaPromises.push(relationshipPromise);
            }
            var versions = (sheetModel.versions ? sheetModel.versions.map(function (l) { return l.ID; }) : null);
            $.post({
                url: '/hdb/getSubTree',
                data: JSON.stringify({ table: "VERSION", list: versions /*, actual:true*/ }),
                processData: true,
                contentType: "application/json",
                headers: {
                    "Accept": "application/json"
                },
            }).done(function (rawdata) {
                var versionTree = (0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.convertHierarchy)(rawdata);
                sheetModel.versionTree = versionTree;
                sheetModel.versionMap = {};
                sheetModel.actualRoot = versionTree.find(function (v) { return (v.VERSION_TYPE === 'Actual'); });
                if (sheetModel.actualRoot) {
                    // sheetModel.actualRoot.group = VueApp.i18n.translate("actual_version");
                    // sheetModel.actualRoot.NAME = VueApp.i18n.translate("actual_version");
                    sheetModel.versionMap[sheetModel.actualRoot.RESULT_NODE] = sheetModel.actualRoot;
                }
                var leafVersions = (0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.getLeafNodes)(versionTree);
                sheetModel.actualVersions = leafVersions.filter(function (v) { return (v.VERSION_TYPE === 'Actual'); });
                for (var i = 0; i < leafVersions.length; i++) {
                    if (leafVersions[i].VERSION_TYPE === "Folder") {
                        var node = leafVersions[i];
                        var parent_1 = node.parent;
                        while (parent_1 && (!node.children || node.children.length === 0)) {
                            var idx = parent_1.children.indexOf(node);
                            parent_1.children.splice(idx, 1);
                            node = parent_1;
                            parent_1 = node.parent;
                        }
                    }
                    else
                        sheetModel.versionMap[leafVersions[i].RESULT_NODE] = leafVersions[i];
                }
                if (sheetModel.versions) {
                    for (var i = 0; i < sheetModel.versions.length; i++) {
                        var ver = sheetModel.versions[i];
                        if (sheetModel.versionMap[ver.ID]) {
                            var freshVer = sheetModel.versionMap[ver.ID];
                            ver.NAME = freshVer.NAME;
                            ver.OP_START = freshVer.OP_START;
                            ver.OP_END = freshVer.OP_END;
                        }
                    }
                }
                sheetModel.actualOnly = (versionTree.length === 1 && sheetModel.actualRoot);
                if (sheetModel.actualRoot && !sheetModel.actualOnly && !sheetModel.inputOnly)
                    sheetModel.actualRoot.children = null;
                // if(!sheetModel.inputOnly && sheetModel.actualRoot && !sheetModel.actualOnly && sheetModel.defaultVersion && sheetModel.defVerActual) {
                // 	sheetModel.defaultVersion = null;
                // }
                if (!sheetModel.defaultVersion) {
                    if (sheetModel.actualRoot) {
                        sheetModel.defaultVersion = sheetModel.actualRoot.RESULT_NODE;
                    }
                    else {
                        var firstVersion = leafVersions.find(function (v) { return (v.VERSION_TYPE !== 'Folder'); });
                        if (firstVersion)
                            sheetModel.defaultVersion = firstVersion.RESULT_NODE;
                    }
                }
                if (extraMetaPromises && extraMetaPromises.length > 0)
                    Promise.all(extraMetaPromises).then(function (_) { resolve(sheetModel); });
                else
                    resolve(sheetModel);
            }).fail(function (jqXHR) {
                console.error(jqXHR.responseText);
                reject(VueApp.i18n.translate("internal_error"));
            });
        }).fail(function (jqXHR) {
            console.error(jqXHR.responseText);
            reject(VueApp.i18n.translate("internal_error"));
        });
    }).then(function (calcViewModel) {
        var fieldList = [calcViewModel.fieldList[0]].concat((0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.sortByKey)(calcViewModel.fieldList.slice(1), "NAME")); //level at first, sort other field
        if (calcViewModel.relList && calcViewModel.relList.length > 0) {
            calcViewModel.relList.forEach(function (rel) {
                if (rel.dim1 !== 'ACCOUNT' && rel.dim2 !== 'ACCOUNT' &&
                    calcViewModel.fieldMap[rel.dim1 + "_NAME"] && calcViewModel.fieldMap[rel.dim2 + "_NAME"]) {
                    var idx1 = fieldList.findIndex(function (f) { return (f.DIM_ID === rel.dim1 && f.ID === "NAME"); });
                    var idx2 = fieldList.findIndex(function (f) { return (f.DIM_ID === rel.dim2 && f.ID === "NAME"); });
                    if (idx1 > idx2) {
                        var tmp = fieldList[idx1];
                        fieldList[idx1] = fieldList[idx2];
                        fieldList[idx2] = tmp;
                    }
                }
            });
        }
        calcViewModel.fieldList = fieldList;
        if (!extended)
            return calcViewModel;
        return Promise.all(extendedPromises).then(function (results) {
            var data = extendedData.snapshots; //isReport===0
            if (data && data.length > 0) {
                calcViewModel.snapshot = data[0].SNAPSHOT;
                calcViewModel.editMode = !!data[0].EDITMODE;
            }
            else {
                var snapShot = extendedData.defSnapshot;
                if (snapShot) {
                    calcViewModel.snapshot = snapShot.CONTENT;
                    calcViewModel.editMode = !!snapShot.EDITMODE;
                }
            }
            var allDimList = extendedData.dimList;
            calcViewModel.allDimList = allDimList;
            if (enableAsset) {
                calcViewModel.allDimList.push({ ID: "ASSET", NAME: VueApp.i18n.translate("assets"), ishierarchy: true, values: [] });
                calcViewModel.allDimList.push({ ID: "ASSET_CLASS", NAME: VueApp.i18n.translate("asset_class"), ishierarchy: true, values: [] });
            }
            calcViewModel._containAllDimID = false;
            var customDimList = calcViewModel.dimList.filter(function (dim) { return (dim.ID !== "LEVEL" && dim.ID !== "ACCOUNT"); });
            if (customDimList.length === allDimList.length) { //at least allDimList,length+1
                var flag = true;
                for (var i = 0; i < customDimList.length; i++) {
                    if (!customDimList[i].fieldMap["NAME"]) {
                        flag = false;
                        break;
                    }
                }
                calcViewModel._containAllDimID = flag;
            }
            calcViewModel.missingDims = [];
            for (var i = 0; i < allDimList.length; i++) {
                var availableDim = allDimList[i];
                var found = false;
                for (var j = 0; j < calcViewModel.inputDimList.length; j++) {
                    var existingDim = calcViewModel.inputDimList[j];
                    if (existingDim.ID === availableDim.ID) {
                        found = true;
                        break;
                    }
                }
                if (!found)
                    calcViewModel.missingDims.push(availableDim);
            }
            for (var i = 0; i < calcViewModel.missingDims.length; i++) {
                var dim = calcViewModel.missingDims[i];
                calcViewModel.dimMap[dim.ID] = dim;
            }
            if (extendedData.dataLock) {
                calcViewModel.enableDatalock = extendedData.dataLock.enabled;
                if (calcViewModel.enableDatalock) {
                    var dataLockDims_1 = extendedData.dataLock.dims;
                    calcViewModel.dimLockList = [];
                    var dimMust = ['ACCOUNT', 'VERSION'];
                    var _loop_1 = function (i) {
                        if (dimMust.indexOf(dataLockDims_1[i].ID) !== -1 || calcViewModel.dimList.find(function (e) { return e.ID === dataLockDims_1[i].ID; })) {
                            calcViewModel.dimLockList.push(dataLockDims_1[i]);
                        }
                        ;
                    };
                    for (var i = 0; i < dataLockDims_1.length; i++) {
                        _loop_1(i);
                    }
                    ;
                    if (extendedData.ifByUser) {
                        calcViewModel.dimLockList.push({ ID: 'USER', isSelected: true });
                        calcViewModel.userList = extendedData.userList;
                    }
                    var defState = extendedData.dataLock.states.find(function (s) { return s.isDefault; });
                    calcViewModel.defState = (defState === null || defState === void 0 ? void 0 : defState.NAME) || 'LOCKED';
                }
            }
            return calcViewModel;
        }).catch(function () {
            return calcViewModel;
        });
    });
}
function passMDX(options, calcViewModel, preview, rawData) {
    console.log("start pass MDX at: " + new Date());
    if (options.dateRange && options.dateRange.values)
        options.dateRange.values = options.dateRange.values.map(function (d) { return (d === 'currentMonth' ? (0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.getCutoffDate)('MONTH') : d); });
    var selectedVersions = options.versions;
    var useMeasures = (calcViewModel.measures && calcViewModel.measures.length > 0);
    var allow_input = permissionObj.DESIGN_TIME_ACCESS.allow_input && calcViewModel.allowInput && !calcViewModel.lock;
    var allow_modify_actual_data = permissionObj.DESIGN_TIME_ACCESS.allow_modify_actual_data;
    var drilldownToBottom = false;
    var singleOpenVersion = false;
    var otherVersions = [];
    var majorVersion = null;
    var multiVersion = false;
    if (!selectedVersions || selectedVersions.length === 0) {
        if (calcViewModel.actualRoot) {
            majorVersion = calcViewModel.actualRoot;
        }
        else {
            var ver = calcViewModel.versionMap[calcViewModel.defaultVersion];
            if (ver)
                majorVersion = ver;
        }
    }
    else {
        multiVersion = selectedVersions.length > 1;
        if (multiVersion) {
            if (options.versionCompare.baseVersion) {
                majorVersion = selectedVersions.find(function (v) { return v.RESULT_NODE === options.versionCompare.baseVersion; });
                otherVersions = selectedVersions.filter(function (v) { return v.RESULT_NODE !== options.versionCompare.baseVersion; });
            }
        }
        else
            majorVersion = selectedVersions[0];
    }
    if (!majorVersion) {
        console.log("Cannot decide version!");
        return;
    }
    var editableVersion = multiVersion ? otherVersions[0] : majorVersion;
    if ((allow_input && !editableVersion.AC_ISLOCKED && (editableVersion.VERSION_TYPE !== "Actual" || allow_modify_actual_data))
        || (calcViewModel.enableDatalock && calcViewModel.defState === 'LOCKED'))
        singleOpenVersion = true;
    // for(let i:number=0;i<selectedVersions.length;i++) {
    // 	const ver:any = selectedVersions[i];
    // 	if((ver.IS_LEAF && !ver.AC_ISLOCKED) || (calcViewModel.enableDatalock && calcViewModel.defState==='LOCKED')) {
    // 		if(singleOpenVersion) {
    // 			singleOpenVersion = false;
    // 			break;
    // 		} else {
    // 			if(ver.VERSION_TYPE!=="Actual" || (ver.IS_LEAF===1 && allow_modify_actual_data))
    // 				singleOpenVersion = true;
    // 		}
    // 	}
    // }
    var allDimExpanded = true;
    var allDims = ["ACCOUNT", "LEVEL"].concat(calcViewModel.inputDimList.map(function (d) { return d.ID; }));
    for (var i = 0; i < allDims.length; i++) {
        var found = false;
        for (var j = 0; j < options.dimFields.length; j++) {
            if (options.dimFields[j].DIM_ID === allDims[i] && options.dimFields[j].ID === "NAME") {
                found = true;
                break;
            }
        }
        if (found)
            continue;
        for (var j = 0; j < options.filters.length; j++) {
            if (options.filters[j].parent === allDims[i] && options.filters[j].code === "ID" && options.filters[j].singleValue) {
                found = true;
                break;
            }
        }
        if (!found) {
            allDimExpanded = false;
            break;
        }
    }
    if (!preview && !options.drilldown && allow_input && singleOpenVersion && typeof options.dateField === "string")
        drilldownToBottom = allDimExpanded;
    if (drilldownToBottom) {
        options.dim2Level = -1;
        options.year_to_date = false;
    }
    var selCols = [];
    var sortCols = [];
    for (var i = 0; i < options.dimFields.length; i++) {
        var dim = options.dimFields[i];
        var colName = dim.DIM_ID + "." + dim.ID;
        selCols.push(colName);
        sortCols.push(colName);
    }
    //const axisDims = options.dimFields.filter(dim=>(dim.ID==='NAME'));
    var axisDims = []; //only contain col dims;
    var dateOnCol = false;
    var ddByDate = true;
    var groupByField = null;
    var groupbyColumns = [];
    var multiOnColDims = (options.onColDims && options.onColDims.length > 1);
    if (!multiOnColDims) {
        if (typeof options.dateField === "string") {
            groupbyColumns.push("FACT." + options.dateField);
            sortCols.push("FACT." + options.dateField);
            dateOnCol = true;
        }
        else {
            ddByDate = false;
            var dim = options.dateField;
            var colName = dim.DIM_ID + "." + dim.ID;
            groupByField = colName;
            groupbyColumns.push(colName);
            sortCols.push(colName);
            if (dim.ID === 'NAME')
                axisDims.push(dim);
        }
    }
    else {
        //options.year_to_date = false;
        for (var i = 0; i < options.onColDims.length; i++) {
            var field = options.onColDims[i];
            if (field.DIM_ID === "DATE") {
                groupbyColumns.push("FACT." + field.ID);
                sortCols.push("FACT." + field.ID);
                dateOnCol = true;
            }
            else {
                var colName = field.DIM_ID + "." + field.ID;
                groupByField = colName;
                groupbyColumns.push(colName);
                sortCols.push(colName);
            }
        }
    }
    if (multiVersion)
        groupbyColumns.push("VERSION.ID");
    if (useMeasures) {
        groupbyColumns.push("MEASURE.ID");
        options.year_to_date = false;
    }
    var compTotalMeasureIDs = new Set();
    if (options.withCompTotal) {
        for (var i = 0; i < calcViewModel.measures.length; i++) {
            var m = calcViewModel.measures[i];
            if (m.RATIO_CALC === 4)
                compTotalMeasureIDs.add('' + m.ID);
        }
    }
    var actualAndPlanDataHasOverLap = (!multiVersion && majorVersion.VERSION_TYPE !== "Actual" && options.versionOverlap && !drilldownToBottom && calcViewModel.actualRoot);
    var actualAndPlanDataCutoffDate = (actualAndPlanDataHasOverLap ? options.cutoffDate : null);
    var sheetId = calcViewModel.id;
    var hasHierarchy = options.hierarchy;
    var dateRange = options.dateRange;
    if (selectedVersions.length > 1 && options.versionCompare && options.versionCompare.comparableVersions) {
        for (var i = 0; i < options.versionCompare.comparableVersions.length; i++) {
            if (options.versionCompare.comparableVersions[i].shift !== 0) {
                dateRange = null;
                break;
            }
        }
    }
    if (options.enablePeriodCompare) {
        if (!dateRange || !dateRange.values || dateRange.values.length === 0) {
            var today = new Date();
            var year = '' + (today.getFullYear() + options.periodCompareBase);
            dateRange = { field: 'YEAR', values: [year, year] };
        }
        else if (dateRange.values.length === 1) {
            var date_1 = dateRange.values[0];
            dateRange.values = [date_1, date_1];
        }
        var periodShiftType = options.periodCompareShift[0];
        var periodShiftValue = parseInt(options.periodCompareShift.substring(1));
        var dateIndex = (periodShiftValue < 0 ? 0 : 1);
        var date = dateRange.values[dateIndex];
        var newDate = (0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.getPeriodShiftValue)(date, periodShiftType, periodShiftValue);
        dateRange.values[dateIndex] = newDate;
    }
    if (useMeasures && calcViewModel.hasTimeMeasure)
        dateRange = null; //do date range filter after MDX query
    var runtimeFilter = options.filters;
    // const requestQueries = [];
    // const originSelCols:string[] = [].concat(selCols);
    var originSelCols = selCols;
    var selectColumns = selCols.join(",");
    var orderbyColumns = sortCols.join(",");
    var dateRangeParam = getDateParam(selectedVersions, options.dateField, dateRange);
    if (dateRangeParam.epmError)
        return Promise.reject({ epmError: true, errorCode: dateRangeParam.epmError });
    dateRangeParam.calculation = (options.year_to_date ? "year_to_date" : "");
    var compareNS = (selectedVersions.length > 1 && options.versionCompare && !options.versionCompare.compareState && !options.versionCompare.compareDate);
    dateRangeParam.nameSets = compareNS ? options.versionCompare.compareNameSets : options.nameSetSelect;
    var drilldownFilter = [];
    var otherFilter = [];
    var dimList = (ddByDate ? options.dimFields : options.dimFields.concat([options.dateField]));
    for (var i = 0; i < runtimeFilter.length; i++) {
        var filter = runtimeFilter[i];
        var found = false;
        if (filter.code === "ID" || filter.code === "NAME") {
            for (var j = 0; j < dimList.length; j++) {
                var dim = dimList[j];
                if (filter.parent === dim.DIM_ID && (filter.code === dim.ID || (filter.code === "ID" && dim.ID === "NAME"))) {
                    found = true;
                    break;
                }
            }
        }
        if (found)
            drilldownFilter.push(filter);
        else
            otherFilter.push(filter);
    }
    // const originOtherFilter = [].concat(otherFilter);
    var originOtherFilter = otherFilter;
    //let compareCopyFrom:boolean = false;
    var majorVersionID = null;
    if (actualAndPlanDataHasOverLap) {
        if (drilldownToBottom)
            actualAndPlanDataCutoffDate = majorVersion.OP_START.substring(0, 7);
    }
    /*if(options.copyFrom && options.compareCopyFrom && !options.year_to_date) {
        const majorVersion:any = selectedVersions[0];
        compareCopyFrom = true;
        majorVersionID = majorVersion.RESULT_NODE;
        versionNOs.push(majorVersion.COPYFROM);
        versionFilterValues.push(majorVersion.COPYFROM);
        multiVersion = true;
        selectColumns += ",VERSION.ID";
    }*/
    otherFilter.push({ code: "ID", parent: "VERSION", values: [majorVersion.RESULT_NODE] });
    if (useMeasures)
        otherFilter.push({ code: "ID", parent: "MEASURE", values: calcViewModel.measures.map(function (m) { return m.ID; }) });
    var currency = options.currency;
    var rateType = options.rateType;
    var mdxDispAttrs = {};
    var allCode = (options.dispAttrs === 'ALL_CODE');
    if (!allCode && options.dispAttrs) {
        for (var dim in options.dispAttrs) {
            var dispAttr = options.dispAttrs[dim];
            if (!dispAttr)
                continue;
            var attrList = (dispAttr instanceof Array ? dispAttr : [dispAttr]);
            var filtedAttrList = attrList.filter(function (attr) { return (attr !== 'LEVEL_NUMBER' && attr !== 'DESCRIPTION'); });
            if (filtedAttrList.length > 0)
                mdxDispAttrs[dim] = filtedAttrList;
        }
    }
    var basicDfs = [];
    if (options.selectedDfs && options.selectedDfs.length > 0) {
        basicDfs = options.selectedDfs.filter(function (d) { return (d[0] !== '$'); });
        if (basicDfs.length > 0)
            basicDfs.sort();
        if ((actualAndPlanDataHasOverLap || options.withCompTotal) && basicDfs.indexOf('YEAR') < 0)
            basicDfs.push('YEAR');
    }
    var queryObj = { currency: currency, rateType: rateType, sheetId: sheetId, actualAndPlanDataHasOverLap: actualAndPlanDataHasOverLap, versionObj: (0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.copyTreeNode)(majorVersion), selectColumns: selectColumns, groupbyColumns: groupbyColumns, orderbyColumns: orderbyColumns, drilldownFilter: drilldownFilter, otherFilter: otherFilter, dateRange: dateRangeParam, hasHierarchy: hasHierarchy, actualAndPlanDataCutoffDate: actualAndPlanDataCutoffDate, aggregateOnCol: true, yearFirst: options.yearFirst, ignoreEmptyTime: options.ignoreEmptyTime,
        dateField: (ddByDate ? options.dateField : groupByField), preview: preview, versionType: majorVersion.VERSION_TYPE, relList: calcViewModel.relQueryList, dispAttrs: allCode ? 'ALL_CODE' : mdxDispAttrs,
        showRefAccounts: options.showRefAccounts, toSheet: options.toSheet, postColDim: options.showLeafFirstOnCol, nameSetOnly: options.nameSetOnly, dfs: basicDfs };
    queryObj.showEmpty = (options.dimFields.length <= 1 && ddByDate) ? (options.showEmpty || !options.drilldown) :
        (options.showEmpty || drilldownToBottom || actualAndPlanDataHasOverLap || multiVersion || options.hasActualPlanAcct);
    if (drilldownToBottom) {
        queryObj.currency = null;
        for (var i = 0; i < calcViewModel.missingDims.length; i++) {
            var dim = calcViewModel.missingDims[i];
            otherFilter.push({ code: "ID", parent: dim.ID, ishierarchy: dim.ishierarchy, values: [-1] });
        }
        queryObj.actualAndPlanDataHasOverLap = false;
    }
    if (options.leafOnly) {
        //queryObj.showEmpty = false;
        queryObj.leafOnly = true;
    }
    //console.log(JSON.stringify(queryObj));
    var axisRelPrmises = [];
    if (calcViewModel.relList && calcViewModel.relList.length > 0 && options.filters && options.filters.length > 0) {
        var _loop_2 = function (k) {
            var dim = axisDims[k];
            var relFilters = [];
            for (var j = 0; j < options.filters.length; j++) {
                var ff = options.filters[j];
                if (ff.parent === dim.DIM_ID && (ff.code === "ID" || ff.code === "NAME")) {
                    relFilters = [];
                    break; //this dim already has filter
                }
                for (var i = 0; i < calcViewModel.relList.length; i++) {
                    var rel = calcViewModel.relList[i];
                    if ((ff.code === "ID" || ff.code === "NAME") && (ff.parent === rel.dim1 || ff.parent === rel.dim2) && (rel.dim1 === dim.DIM_ID || rel.dim2 === dim.DIM_ID)) {
                        relFilters.push({ relationship: rel, filter: ff });
                    }
                }
            }
            if (relFilters.length > 0) {
                var relQuery = { table: dim.DIM_ID, relationships: relFilters };
                if (dim.DIM_ID === "ACCOUNT")
                    relQuery.hierarchy = calcViewModel.accountHierarchy;
                else if (dim.DIM_ID === "LEVEL")
                    relQuery.hierarchy = calcViewModel.levelHierarchy;
                axisRelPrmises.push(Promise.resolve($.post({
                    url: '/hdb/getSubTree',
                    data: JSON.stringify(relQuery),
                    processData: true,
                    contentType: "application/json",
                    headers: {
                        "Accept": "application/json"
                    },
                }).then(function (rawdata) {
                    var values = rawdata.filter(function (d) { return (d.IS_LEAF); }).map(function (d) { return d.RESULT_NODE; });
                    queryObj.otherFilter.push({ code: "ID", parent: dim.DIM_ID, ishierarchy: dim.ishierarchy, values: values });
                })));
            }
        };
        for (var k = 0; k < axisDims.length; k++) {
            _loop_2(k);
        }
    }
    var dataPromise = axisRelPrmises.length === 0 ? getDataPromise(queryObj) :
        Promise.all(axisRelPrmises).then(function (_) { return getDataPromise(queryObj); });
    if (rawData || options.toSheet)
        return dataPromise;
    var notePromise = null;
    function getNoteContent(row) {
        var noteContent = { content: row["CELL_NOTE"], userName: row["USER_NAME"], userId: row["USER_ID"], sheetOnly: (row["SHEET_ID"] == calcViewModel.id), modelSheet: row["MODEL_SHEET"], row: row };
        if (row["MISC"]) {
            try {
                noteContent.misc = JSON.parse(row["MISC"]);
            }
            catch (ex) { }
        }
        return noteContent;
    }
    if (ddByDate /*&& options.dateField==="MONTH"*/) {
        notePromise = getNotePromise(queryObj);
    }
    var dataLockPromise = null;
    if ((drilldownToBottom || (options.drilldown && options.leafOnly)) && enableDatalock)
        dataLockPromise = getDataLockPromise(queryObj);
    var indexCols = [];
    for (var i = 0; i < options.dimFields.length; i++) {
        var dim = options.dimFields[i];
        var colName = (dim.ID === "NAME" ? dim.DIM_ID : dim.ID) + "_ID";
        indexCols.push(colName);
    }
    var resultPromise = processSingleVersionData(queryObj, dataPromise, notePromise, dataLockPromise).then(function (result) {
        if (multiVersion || actualAndPlanDataHasOverLap) {
            var promises = actualAndPlanDataHasOverLap ? [processOtherVersion(calcViewModel.actualRoot, queryObj)]
                : otherVersions.map(function (v) { return processOtherVersion(v, queryObj); });
            return Promise.all(promises).then(function (results) {
                var mergeActualData = null;
                var finalResult = result.rowData;
                if (actualAndPlanDataHasOverLap) {
                    var actualResult = results[0];
                    var actualTree = actualResult.rowData;
                    result.actualDateFieldList = actualResult.dateFieldList;
                    var actualHash_1 = getResultHash(actualTree);
                    var cutoffDateYear_1 = actualAndPlanDataCutoffDate.substring(0, 4);
                    mergeActualData = function (node) {
                        for (var prop in node) {
                            if (prop.substring(0, 5) === "date-") {
                                var timeVal = prop.substring(5);
                                if (timeVal.length === 4) {
                                    if (timeVal < cutoffDateYear_1)
                                        delete node[prop];
                                }
                                else {
                                    if (timeVal < actualAndPlanDataCutoffDate || options.overlapWholeYear)
                                        delete node[prop];
                                }
                            }
                        }
                        if (node.notes) {
                            for (var prop in node.notes) {
                                if (prop.substring(0, 5) === "date-") {
                                    var timeVal = prop.substring(5);
                                    if (timeVal.length === 4) {
                                        if (timeVal < cutoffDateYear_1)
                                            delete node.notes[prop];
                                    }
                                    else {
                                        if (timeVal < actualAndPlanDataCutoffDate || options.overlapWholeYear)
                                            delete node.notes[prop];
                                    }
                                }
                            }
                        }
                        var indexValues = [];
                        for (var i = 0; i < indexCols.length; i++) {
                            indexValues.push(node[indexCols[i]]);
                        }
                        var index = indexValues.join("_");
                        var actualData = actualHash_1[index];
                        if (actualData && !actualData.hidden) {
                            node.hidden = false;
                            for (var prop in actualData) {
                                if (prop.substring(0, 5) === "date-") {
                                    var timeVal = prop.substring(5);
                                    if (timeVal.length === 4) {
                                        if (timeVal < cutoffDateYear_1)
                                            node[prop] = actualData[prop];
                                    }
                                    else {
                                        if (timeVal < actualAndPlanDataCutoffDate || options.overlapWholeYear)
                                            node[prop] = actualData[prop];
                                    }
                                }
                            }
                            if (actualData.notes) {
                                if (!node.notes)
                                    node.notes = {};
                                for (var prop in actualData.notes) {
                                    if (prop.substring(0, 5) === "date-") {
                                        var timeVal = prop.substring(5);
                                        if (timeVal.length === 4) {
                                            if (timeVal < cutoffDateYear_1)
                                                node.notes[prop] = actualData.notes[prop];
                                        }
                                        else {
                                            if (timeVal < actualAndPlanDataCutoffDate || options.overlapWholeYear)
                                                node.notes[prop] = actualData.notes[prop];
                                        }
                                    }
                                }
                            }
                        }
                        return { check: false, children: node.children };
                    };
                }
                else {
                    var majorVerNo_1 = majorVersion.RESULT_NODE;
                    var actualVerNos_1 = otherVersions.map(function (v) { return v.RESULT_NODE; });
                    var actualHashList_1 = results.map(function (r) { return getResultHash(r.rowData); });
                    mergeActualData = function (node) {
                        for (var prop in node) {
                            if (prop.substring(0, 5) === "date-") {
                                var newProp = prop + "-v" + majorVerNo_1;
                                node[newProp] = node[prop];
                                delete node[prop];
                            }
                        }
                        if (node.notes) {
                            for (var prop in node.notes) {
                                if (prop.substring(0, 5) === "date-") {
                                    var newProp = prop + "-v" + majorVerNo_1;
                                    node.notes[newProp] = node.notes[prop];
                                    delete node.notes[prop];
                                }
                            }
                        }
                        var indexValues = [];
                        for (var i = 0; i < indexCols.length; i++) {
                            indexValues.push(node[indexCols[i]]);
                        }
                        var index = indexValues.join("_");
                        for (var i = 0; i < actualHashList_1.length; i++) {
                            var actualHash = actualHashList_1[i];
                            var actualData = actualHash[index];
                            var actualVerNo = actualVerNos_1[i];
                            if (actualData && !actualData.hidden) {
                                node.hidden = false;
                                for (var prop in actualData) {
                                    if (prop.substring(0, 5) === "date-") {
                                        var newProp = prop;
                                        /*if(singleActualVersion) */ newProp = prop + "-v" + actualVerNo;
                                        node[newProp] = actualData[prop];
                                    }
                                }
                                if (actualData.notes) {
                                    if (!node.notes)
                                        node.notes = {};
                                    for (var prop in actualData.notes) {
                                        if (prop.substring(0, 5) === "date-") {
                                            var newProp = prop;
                                            /*if(singleActualVersion) */ newProp = prop + "-v" + actualVerNo;
                                            node.notes[newProp] = actualData.notes[prop];
                                        }
                                    }
                                }
                            }
                        }
                        return { check: false, children: node.children };
                    };
                }
                finalResult.forEach(function (n) { return (0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.treeDFSTravers)(n, mergeActualData); });
                return result;
            });
        }
        else
            return result;
    }).catch(function (err) {
        console.log(err);
        if (err === "empty_result")
            throw err;
        else if (err.userFriendly)
            throw err.message;
        else {
            if (err.responseText) {
                var errObj = null;
                try {
                    errObj = JSON.parse(err.responseText);
                }
                catch (e) {
                    throw VueApp.i18n.translate("internal_error");
                }
                if (errObj && errObj.userFriendly)
                    throw errObj.message;
                else
                    throw VueApp.i18n.translate("internal_error");
            }
            else
                throw VueApp.i18n.translate("internal_error");
        }
    }).then(function (result) {
        if ((options.aggregateCode === 4 && options.hierarchy) || preview) {
            var hierDim = options.dimFields[0];
            var branchNodes = null, found = false;
            for (var i = 0; i < options.filters.length; i++) {
                var ff = options.filters[i];
                if (ff.parent === hierDim.DIM_ID && (ff.code === hierDim.ID || (ff.code === "ID" && hierDim.ID === "NAME"))) {
                    branchNodes = ff.values;
                    found = true;
                    break;
                }
            }
            if (!found) {
                if (hierDim.ID === "NAME" && hierDim.DIM_ID === "ACCOUNT") {
                    branchNodes = calcViewModel.accountBranchs;
                }
                else if (hierDim.ID === "NAME" && hierDim.DIM_ID === "LEVEL") {
                    branchNodes = calcViewModel.levelBranchs;
                }
                else {
                    branchNodes = hierDim.values ? hierDim.values.map(function (v) { return v.ID; }) : null;
                }
            }
            if (branchNodes && branchNodes.length > 0) {
                var dimID = hierDim.ID === "NAME" ? hierDim.DIM_ID + "_ID" : hierDim.ID + "_ID";
                var newRowData = getBranches(branchNodes, result.rowData, dimID, preview);
                if (options.aggregateCode === 4 && options.hierarchy)
                    result.rowData = newRowData;
            }
            return result;
        }
        else
            return result;
    });
    if (!options.excel && options.hierarchy && !options.leafOnly) {
        resultPromise = resultPromise.then(convertToNewTreeData);
        if (drilldownToBottom && options.showLeafOnly)
            resultPromise = resultPromise.then(getLeafOnly.bind(null, options));
    }
    else
        resultPromise = resultPromise.then(function (result) {
            result.rowData.forEach(function (r, index) {
                r.path = [index];
            });
            return result;
        });
    if ((useMeasures && calcViewModel.hasTimeMeasure) || options.enablePeriodCompare)
        resultPromise = resultPromise.then(filterDateRange);
    if (options.ignoreUndefined)
        resultPromise = resultPromise.then(filterUndefined);
    if (drilldownToBottom && options.showComments)
        resultPromise = resultPromise.then(function (result) {
            for (var i = 0; i < result.rowData.length; i++) {
                var row = result.rowData[i];
                if (row.notes) {
                    for (var field in row.notes) {
                        if (field.substring(0, 5) === "date-") {
                            var notes = row.notes[field];
                            if (notes.length > 0) {
                                var content = notes[0].content;
                                row["note-" + field] = content;
                            }
                        }
                    }
                }
            }
            return result;
        });
    return resultPromise;
    function getResultHash(actualTree) {
        var actualHash = {};
        function getActualHash(node) {
            var indexValues = [];
            for (var i = 0; i < indexCols.length; i++) {
                indexValues.push(node[indexCols[i]]);
            }
            var index = indexValues.join("_");
            actualHash[index] = node;
            return { check: false, children: node.children };
        }
        actualTree.forEach(function (n) { return (0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.treeDFSTravers)(n, getActualHash); });
        return actualHash;
    }
    function processOtherVersion(otherVersion, queryObj) {
        var otherQueryObj = null;
        otherQueryObj = objectAssign({}, queryObj);
        otherQueryObj.versionObj = (0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.copyTreeNode)(otherVersion);
        var otherDateRangeParam = getDateParam([otherVersion], options.dateField, dateRange);
        if (otherDateRangeParam.epmError)
            return Promise.reject({ epmError: true, errorCode: otherDateRangeParam.epmError });
        otherDateRangeParam.calculation = (options.year_to_date ? "year_to_date" : "");
        otherQueryObj.dateRange = otherDateRangeParam;
        otherQueryObj.dateRange.nameSets = dateRangeParam.nameSets;
        otherQueryObj.otherFilter = originOtherFilter.filter(function (f) { return f.parent !== "VERSION"; }).concat([{ code: "ID", parent: "VERSION", values: [otherVersion.RESULT_NODE] }]);
        otherQueryObj.versionType = otherVersion.VERSION_TYPE;
        otherQueryObj.selectColumns = originSelCols.join(",");
        var actualDataPromise = null, actualNotePromise = null, actualDataLockPromise = null;
        actualDataPromise = getDataPromise(otherQueryObj);
        if (ddByDate /*&& options.dateField==="MONTH"*/) {
            actualNotePromise = getNotePromise(otherQueryObj);
        }
        if (drilldownToBottom && enableDatalock)
            actualDataLockPromise = getDataLockPromise(otherQueryObj);
        return processSingleVersionData(otherQueryObj, actualDataPromise, actualNotePromise, actualDataLockPromise);
    }
    function processSingleVersionData(queryObj, dataPromise, notePromise, dataLockPromise) {
        var resultPromise = Promise.all([dataPromise, notePromise, dataLockPromise]).then(function (_a) {
            var mdxResult = _a[0], noteRoot = _a[1], dataLockRoot = _a[2];
            return processMDXResult(mdxResult, noteRoot, dataLockRoot, { majorVersionID: queryObj.versionObj.RESULT_NODE, processEmpty: true });
        });
        if (!ddByDate && options.dateField.flagAttr && options.dateField.flagAttrVal) {
            var otherQueryObj_1 = objectAssign({}, queryObj);
            otherQueryObj_1.otherFilter = otherQueryObj_1.otherFilter.concat([{ code: options.dateField.flagAttr, parent: options.dateField.DIM_ID, values: [options.dateField.flagAttrVal] }]);
            resultPromise = resultPromise.then(function (result) {
                return getDataPromise(otherQueryObj_1).then(function (actualMdxResult) {
                    var actualHash = {};
                    try {
                        var pmOptions = { majorVersionID: queryObj.versionObj.RESULT_NODE };
                        var actualResult = processMDXResult(actualMdxResult, null, null, pmOptions);
                        var actualTree = actualResult.rowData;
                        actualHash = getResultHash(actualTree);
                    }
                    catch (ex) {
                        //do nothing
                    }
                    var finalResult = result.rowData;
                    var mergeActualData = function (node) {
                        var indexValues = [];
                        for (var i = 0; i < indexCols.length; i++) {
                            indexValues.push(node[indexCols[i]]);
                        }
                        var index = indexValues.join("_");
                        var actualData = actualHash[index];
                        if (actualData && !actualData.hidden) {
                            node.hidden = false;
                            for (var prop in actualData) {
                                if (prop.substring(0, 5) === "date-") {
                                    var newProp = prop + "-adjust";
                                    node[newProp] = actualData[prop];
                                }
                            }
                            if (actualData.notes) {
                                if (!node.notes)
                                    node.notes = {};
                                for (var prop in actualData.notes) {
                                    if (prop.substring(0, 5) === "date-") {
                                        var newProp = prop + "-adjust";
                                        node.notes[newProp] = actualData.notes[prop];
                                    }
                                }
                            }
                        }
                        return { check: false, children: node.children };
                    };
                    finalResult.forEach(function (n) { return (0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.treeDFSTravers)(n, mergeActualData); });
                    return result;
                });
            });
        }
        if (options.hasActualPlanAcct && queryObj.versionType != "Actual") {
            var otherQueryObj_2 = objectAssign({}, queryObj);
            otherQueryObj_2.multiVersion = false;
            otherQueryObj_2.versionType = "Actual";
            resultPromise = resultPromise.then(function (result) {
                return getDataPromise(otherQueryObj_2).then(function (actualMdxResult) {
                    var actualHash = {};
                    try {
                        var pmOptions = { majorVersionID: queryObj.versionObj.RESULT_NODE };
                        pmOptions.splitOtherVersion = true;
                        var actualResult = processMDXResult(actualMdxResult, null, null, pmOptions);
                        var actualTree = actualResult.rowData;
                        actualHash = getResultHash(actualTree);
                    }
                    catch (ex) {
                        //do nothing
                    }
                    var finalResult = result.rowData;
                    var mergeActualData = function (node) {
                        var indexValues = [];
                        for (var i = 0; i < indexCols.length; i++) {
                            indexValues.push(node[indexCols[i]]);
                        }
                        var index = indexValues.join("_");
                        var actualData = actualHash[index];
                        var acctId = node["ACCOUNT_ID"];
                        if (!acctId)
                            return { check: false, children: node.children };
                        var acct = (0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.getStore)().getters.accountIdMap[acctId];
                        if (!acct || acct.ACTUAL_DATA !== 3)
                            return { check: false, children: node.children };
                        if (actualData && !actualData.hidden) {
                            node.hidden = false;
                            for (var prop in actualData) {
                                if (prop.substring(0, 5) === "date-") {
                                    if (!node[prop]) {
                                        node[prop] = actualData[prop];
                                        node[prop + "_actual"] = true;
                                    }
                                }
                            }
                        }
                        return { check: false, children: node.children };
                    };
                    finalResult.forEach(function (n) { return (0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.treeDFSTravers)(n, mergeActualData); });
                    return result;
                });
            });
        }
        if (queryObj.versionObj.AC_ACTUAL_ACCESS && queryObj.versionObj.OP_ACTUALS_VERSION_OVERLAY) {
            var otherVersionObj = (0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.getStore)().getters.versionMap[queryObj.versionObj.OP_ACTUALS_VERSION_OVERLAY];
            if (otherVersionObj) {
                var otherQueryObj_3 = objectAssign({}, queryObj);
                otherQueryObj_3.multiVersion = false;
                otherQueryObj_3.versionType = otherVersionObj.VERSION_TYPE;
                otherQueryObj_3.versionObj = objectAssign({}, otherVersionObj);
                for (var i = 0; i < otherQueryObj_3.otherFilter.length; i++) {
                    var ff = otherQueryObj_3.otherFilter[i];
                    if (ff.parent === 'VERSION') {
                        ff.values = [otherVersionObj.RESULT_NODE];
                        break;
                    }
                }
                resultPromise = resultPromise.then(function (result) {
                    return getDataPromise(otherQueryObj_3).then(function (actualMdxResult) {
                        var actualHash = {};
                        try {
                            var pmOptions = { majorVersionID: queryObj.versionObj.RESULT_NODE };
                            var actualResult = processMDXResult(actualMdxResult, null, null, pmOptions);
                            var actualTree = actualResult.rowData;
                            actualHash = getResultHash(actualTree);
                        }
                        catch (ex) {
                            //do nothing
                        }
                        var finalResult = result.rowData;
                        var cutoffDate = (0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.getMonthAfter)(queryObj.versionObj.OP_START, queryObj.versionObj.AC_ACTUAL_ACCESS - 1);
                        var cutoffDateYear = cutoffDate.substring(0, 4);
                        var mergeActualData = function (node) {
                            for (var prop in node) {
                                if (prop.substring(0, 5) === "date-") {
                                    var timeVal = prop.substring(5);
                                    if (timeVal.length === 4) {
                                        if (timeVal < cutoffDateYear)
                                            delete node[prop];
                                    }
                                    else {
                                        if (timeVal <= cutoffDate)
                                            delete node[prop];
                                    }
                                }
                            }
                            if (node.notes) {
                                for (var prop in node.notes) {
                                    if (prop.substring(0, 5) === "date-") {
                                        var timeVal = prop.substring(5);
                                        if (timeVal.length === 4) {
                                            if (timeVal < cutoffDateYear)
                                                delete node.notes[prop];
                                        }
                                        else {
                                            if (timeVal <= cutoffDate)
                                                delete node.notes[prop];
                                        }
                                    }
                                }
                            }
                            var indexValues = [];
                            for (var i = 0; i < indexCols.length; i++) {
                                indexValues.push(node[indexCols[i]]);
                            }
                            var index = indexValues.join("_");
                            var actualData = actualHash[index];
                            if (actualData && !actualData.hidden) {
                                node.hidden = false;
                                for (var prop in actualData) {
                                    if (prop.substring(0, 5) === "date-") {
                                        var timeVal = prop.substring(5);
                                        if (timeVal.length === 4) {
                                            if (timeVal < cutoffDateYear)
                                                node[prop] = actualData[prop];
                                        }
                                        else {
                                            if (timeVal <= cutoffDate)
                                                node[prop] = actualData[prop];
                                        }
                                    }
                                }
                                if (actualData.notes) {
                                    if (!node.notes)
                                        node.notes = {};
                                    for (var prop in actualData.notes) {
                                        if (prop.substring(0, 5) === "date-") {
                                            var timeVal = prop.substring(5);
                                            if (timeVal.length === 4) {
                                                if (timeVal < cutoffDateYear)
                                                    node.notes[prop] = actualData.notes[prop];
                                            }
                                            else {
                                                if (timeVal <= cutoffDate)
                                                    node.notes[prop] = actualData.notes[prop];
                                            }
                                        }
                                    }
                                }
                            }
                            return { check: false, children: node.children };
                        };
                        finalResult.forEach(function (n) { return (0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.treeDFSTravers)(n, mergeActualData); });
                        return result;
                    });
                });
            }
        }
        return resultPromise;
    }
    function processMDXResult(mdxResult, noteRoot, dataLockRoot, processOptions) {
        var processEmpty = processOptions.processEmpty, majorVersionID = processOptions.majorVersionID, splitOtherVersion = processOptions.splitOtherVersion;
        var accountMap = (0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.getStore)().getters.accountIdMap;
        var cells = mdxResult.cell;
        if (!drilldownToBottom && (!cells || cells.length === 0) && !processEmpty)
            throw "empty_result";
        if (cells.length > max_rows * 100)
            throw new _ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.EPM2Error(true, VueApp.i18n.translate("too_many_rows"));
        var input = mdxResult.axis1;
        if (!input || input.length === 0)
            throw "empty_result";
        var result = [];
        var levelStack = [result];
        var siblings = result;
        var node = {};
        var valueNode = null;
        var prevDim = null;
        var prevCode = "";
        var axisMap = {};
        var axis1List = [];
        var axis0List = [];
        for (var i = 0; i < mdxResult.axisinfo.length; i++) {
            var axis = mdxResult.axisinfo[i];
            axisMap[axis.DIMENSION.toUpperCase()] = axis;
            if (axis.AXIS === 0) {
                if (axis.DIMENSION !== "Version")
                    axis0List.push(axis);
            }
            else if (axis.AXIS === 1)
                axis1List.push(axis);
        }
        var timeAxisID = mdxResult.axisinfo[0].DIMENSION; //may not be time
        var timeAxisHierarchy = getDimHierarchy(timeAxisID, calcViewModel);
        var timeLevelField = "[".concat(timeAxisID, "].[").concat(timeAxisHierarchy, "].[LEVEL_NUMBER]");
        var timeNameField = "[".concat(timeAxisID, "].[").concat(timeAxisHierarchy, "].[MEMBER_CAPTION]");
        var timeUnField = "[".concat(timeAxisID, "].[").concat(timeAxisHierarchy, "].[MEMBER_UNIQUE_NAME]");
        var timeChildField = "[".concat(timeAxisID, "].[").concat(timeAxisHierarchy, "].[CHILDREN_CARDINALITY]");
        var timeAxis = mdxResult.axis0;
        var dateFieldList = [];
        var measureRe = /\[.*\]\.\[.*\]\.(\&\[(-?\d*)\])|(\[BALANCE_(\d*)\])/;
        var fieldList = [];
        var colFields = [];
        for (var i = 0; i < timeAxis.length; i++) {
            var axisNode = timeAxis[i];
            var fieldStr = 'date';
            var dimValList = [];
            var withRoot = false;
            var skip = false;
            for (var j = 0; j < axis0List.length; j++) {
                var dim = axis0List[j].DIMENSION;
                var dimHiearchy = getDimHierarchy(dim, calcViewModel);
                var val = ((dim === "Time" || dim === 'Measures') ? axisNode["[".concat(dim, "].[").concat(dim, "].[MEMBER_CAPTION]")] : mdxRetrieveValue(axisNode["[".concat(dim, "].[").concat(dimHiearchy, "].[MEMBER_UNIQUE_NAME]")]));
                var name_1 = axisNode["[".concat(dim, "].[").concat(dimHiearchy, "].[MEMBER_CAPTION]")];
                var level = axisNode["[".concat(dim, "].[").concat(dimHiearchy, "].[LEVEL_NUMBER]")];
                var isLeaf = (axisNode["[".concat(dim, "].[").concat(dimHiearchy, "].[CHILDREN_CARDINALITY]")] === 0);
                if (options.onColLevel >= 0 && dim !== "Time") {
                    if (options.onColLevel < 9) {
                        if (options.onColLevel !== level)
                            skip = true;
                    }
                    else { //leaf only
                        if (!isLeaf)
                            skip = true;
                    }
                }
                if (val === "-1") {
                    if (name_1 === "UNDEFINED")
                        name_1 = VueApp.i18n.translate("undefined");
                    if (options.ignoreUndefined)
                        skip = true;
                }
                else if (val === "0") {
                    if (name_1 === "ALL")
                        name_1 = VueApp.i18n.translate("all");
                }
                var dimVal = { DIM: dim, ID: val, NAME: name_1, LEVEL: level, IS_LEAF: isLeaf, VALUE: val };
                if (options.onColDims && options.onColDims[j]) {
                    var colDim = options.onColDims[j];
                    var field = colDim.ID === 'NAME' ? colDim.DIM_ID : colDim.ID;
                    if (options.dispAttrs && options.dispAttrs[field]) {
                        var dispAttr = options.dispAttrs[field];
                        var attrList = (dispAttr instanceof Array ? dispAttr : [dispAttr]);
                        for (var k = 0; k < attrList.length; k++) {
                            var attr = attrList[k];
                            dimVal[field + "_" + attr] = axisNode["[".concat(dim, "].[").concat(dimHiearchy, "].[").concat(attr, "]")];
                        }
                    }
                }
                dimValList.push(dimVal);
                fieldStr += "-d[".concat(val, "]");
                if (j === axis0List.length - 1) {
                    dimVal.fieldVal = fieldStr;
                    fieldList.push(fieldStr);
                }
                if (withRoot) {
                    if (dim !== "Time" && val !== "0")
                        skip = true;
                }
                else {
                    if (val === "0")
                        withRoot = true;
                }
            }
            if (!skip)
                colFields.push(dimValList);
        }
        var measureResult = (!multiOnColDims && options.year_to_date) || useMeasures;
        if (measureResult) {
            var firstTimeVal = null;
            for (var i = 0; i < timeAxis.length; i++) {
                if (measureResult) {
                    if (options.year_to_date) {
                        var mField = timeAxis[i]["[Measures].[Measures].[MEMBER_UNIQUE_NAME]"];
                        timeAxis[i].measureID = (mField === "[Measures].[YEAR_TO_DATE]" ? "YEAR_TO_DATE" : "AMOUNT");
                    }
                    else { //measure
                        var mField = timeAxis[i]["[Measure].[Measure].[MEMBER_UNIQUE_NAME]"];
                        var match = measureRe.exec(mField);
                        if (match) {
                            if (match[2])
                                timeAxis[i].measureID = match[2];
                            else if (match[4]) {
                                timeAxis[i].measureID = match[4];
                                timeAxis[i].isInit = true;
                            }
                        }
                    }
                }
                var timVal = timeAxis[i][timeNameField];
                if (timVal !== firstTimeVal) {
                    firstTimeVal = timVal;
                    if (ddByDate)
                        dateFieldList.push({ value: timVal, level: timeAxis[i][timeLevelField] });
                    else {
                        var colValue = mdxRetrieveValue(timeAxis[i][timeUnField]);
                        var isLeaf = (timeAxis[i][timeChildField] === 0);
                        var level = timeAxis[i][timeLevelField];
                        var skip = false;
                        if (options.onColLevel >= 0) {
                            if (options.onColLevel < 9) {
                                if (options.onColLevel !== level)
                                    skip = true;
                            }
                            else { //leaf only
                                if (!isLeaf)
                                    skip = true;
                            }
                        }
                        if ((!options.ignoreUndefined || colValue != -1) && (!skip)) { //may compare string with number 
                            dateFieldList.push({ name: timVal, value: colValue, isLeaf: isLeaf });
                        }
                    }
                }
                /*if(compareCopyFrom && timeAxis[i].versionNo!=majorVersionID && timeAxis[i][timeLevelField]===0) {
                    dateFieldList.push({name:timeAxis[i]["[Version].[Version].[MEMBER_CAPTION]"], value:"COPYFROM", level:-1});
                }*/
            }
        }
        else {
            for (var i = 0; i < timeAxis.length; i++) {
                if (ddByDate)
                    dateFieldList.push({ value: timeAxis[i][timeNameField], level: timeAxis[i][timeLevelField] });
                else {
                    var colValue = mdxRetrieveValue(timeAxis[i][timeUnField]);
                    var isLeaf = (timeAxis[i][timeChildField] === 0);
                    var level = timeAxis[i][timeLevelField];
                    var skip = false;
                    if (options.onColLevel >= 0) {
                        if (options.onColLevel < 9) {
                            if (options.onColLevel !== level)
                                skip = true;
                        }
                        else { //leaf only
                            if (!isLeaf)
                                skip = true;
                        }
                    }
                    if ((!options.ignoreUndefined || colValue != -1) && (!skip)) { //may compare string with number 
                        dateFieldList.push({ name: timeAxis[i][timeNameField], value: colValue, isLeaf: isLeaf });
                    }
                }
            }
        }
        if (!ddByDate) {
            for (var i = 0; i < dateFieldList.length; i++) {
                var df = dateFieldList[i];
                if (df.value === "-1") {
                    if (df.name === "UNDEFINED")
                        df.name = VueApp.i18n.translate("undefined");
                }
                else if (df.value === "0") {
                    if (df.name === "ALL")
                        df.name = VueApp.i18n.translate("all");
                }
            }
        }
        var axisDim = axis1List[0].DIMENSION; //eg. Account, if hasHierrarchy===true
        var dimHierarchy = getDimHierarchy(axisDim, calcViewModel);
        var hierarchyPrefix = "[".concat(axisDim, "].[").concat(dimHierarchy, "]");
        var op_codeField = "".concat(hierarchyPrefix, ".[MEMBER_UNIQUE_NAME]");
        var op_nameField = "".concat(hierarchyPrefix, ".[MEMBER_CAPTION]");
        var op_levelField = "".concat(hierarchyPrefix, ".[LEVEL_NUMBER]");
        var op_leafField = "".concat(hierarchyPrefix, ".[CHILDREN_CARDINALITY]");
        var resultInHierarchy = (options.hierarchy && !options.leafOnly); // && input.length>0 && input[0][op_levelField]===0);
        var dimPrefixes = [];
        var dimMDXNames = [];
        var dimMDXLevels = [];
        var dimMDXValues = [];
        var dimUINames = [];
        var dimChildNums = [];
        var preDims = {};
        for (var k = 0; k < options.dimFields.length; k++) {
            var dim = options.dimFields[k];
            var dimName = (dim.ID === "NAME" ? "".concat(dim.DIM_ID, "_NAME") : "".concat(dim.ID, "_NAME"));
            dimUINames.push(dimName);
            var axis = axisMap[(dim.ID === "NAME" ? dim.DIM_ID : dim.ID)];
            var axisName = axis.DIMENSION;
            var dimHierarchy_1 = getDimHierarchy(axisName, calcViewModel);
            var prefix = "[".concat(axisName, "].[").concat(dimHierarchy_1, "]");
            dimPrefixes.push(prefix);
            dimChildNums.push("".concat(prefix, ".[CHILDREN_CARDINALITY]"));
            var rowField = "".concat(prefix, ".[MEMBER_CAPTION]");
            dimMDXNames.push(rowField);
            dimMDXLevels.push("".concat(prefix, ".[LEVEL_NUMBER]"));
            var rowValueField = "".concat(prefix, ".[MEMBER_UNIQUE_NAME]");
            dimMDXValues.push(rowValueField);
            if (dim.ID === "NAME")
                preDims[dim.DIM_ID] = true;
            else if (preDims[dim.DIM_ID])
                dim.isAttrCol = true; //an attribute follow dim
        }
        var cellIdx = 0;
        var upperOrdinal = 0;
        var timeCoordinates = mdxResult.axisinfo[0].COORDINATES;
        var dimStartIdx = (resultInHierarchy ? 1 : 0);
        var dimUpper = options.dimFields.length;
        var firstRow = input[0];
        var topLevels = [];
        for (var k = 0; k < dimUpper; k++) {
            topLevels.push(firstRow[dimMDXLevels[k]]);
        }
        var rootLevel = 9999;
        for (var i = 0; i < input.length; i++) {
            try {
                var row = input[i];
                var level = row[op_levelField];
                if (resultInHierarchy) {
                    if (level < rootLevel)
                        rootLevel = level;
                    level = level - rootLevel;
                }
                var ignore = false;
                var _undefined = false;
                for (var k = 0; k < dimUpper; k++) {
                    var dimObj = options.dimFields[k];
                    var name_2 = row[dimMDXNames[k]];
                    var dimVal = dimMDXValues[k];
                    var code = mdxRetrieveValue(row[dimVal]);
                    if (code === "-1") {
                        if (name_2 === "UNDEFINED")
                            row[dimMDXNames[k]] = VueApp.i18n.translate("undefined");
                        _undefined = true;
                    }
                    else if (code === "0") {
                        if (name_2 === "ALL")
                            row[dimMDXNames[k]] = VueApp.i18n.translate("all");
                    }
                }
                //if(options.ignoreUndefined && _undefined) ignore = true;
                var fakeLeaf = false;
                if (options.dimFields[0].DIM_ID === "LEVEL" && options.dimFields[0].ID === "NAME" && options.drillTo >= 0) {
                    if (level === options.drillTo)
                        fakeLeaf = true;
                    else if (level > options.drillTo)
                        ignore = true;
                }
                if (!ignore && resultInHierarchy && row[op_codeField] !== prevCode) {
                    siblings = levelStack[level];
                    if (!siblings)
                        continue;
                    var code = mdxRetrieveValue(row[op_codeField]);
                    var name_3 = row[op_nameField];
                    node = { group: name_3, groupId: code, LEVEL: level, children: [] };
                    var dimName = options.dimFields[0].ID === "NAME" ? options.dimFields[0].DIM_ID : options.dimFields[0].ID;
                    node[dimName + "_NAME"] = name_3;
                    node[dimName + "_ID"] = code;
                    siblings.push(node);
                    levelStack[level + 1] = node.children;
                    prevDim = null;
                }
                var currentDim = {};
                currentDim.firstDimLeaf = (row[op_leafField] === 0);
                if (resultInHierarchy) {
                    var dimName = options.dimFields[0].ID === "NAME" ? options.dimFields[0].DIM_ID : options.dimFields[0].ID;
                    currentDim[dimName + "_NAME"] = node[dimName + "_NAME"];
                    currentDim[dimName + "_ID"] = node[dimName + "_ID"];
                    if (allCode) {
                        var field = "".concat(dimPrefixes[0], ".[CODE]");
                        currentDim[dimName + "_NAME"] += "(".concat(row[field], ")");
                    }
                    else if (options.dispAttrs && options.dispAttrs[dimName]) {
                        var dispAttr = options.dispAttrs[dimName];
                        var attrList = (dispAttr instanceof Array ? dispAttr : [dispAttr]);
                        for (var k = 0; k < attrList.length; k++) {
                            var attr = attrList[k];
                            var attrVal = '';
                            if (attr === 'DESCRIPTION') { //must be account
                                var acct = (0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.getStore)().getters.accountIdMap[node[dimName + "_ID"]];
                                if (acct)
                                    attrVal = acct.DESCRIPTION;
                            }
                            else {
                                var field = "".concat(dimPrefixes[0], ".[").concat(attr, "]");
                                attrVal = row[field];
                            }
                            currentDim[dimName + "_" + attr] = attrVal;
                        }
                    }
                } /*else if(options.hierarchy) {
                    currentDim.group = row[dimMDXNames[0]];
                    currentDim.groupId = mdxRetrieveValue(row[dimMDXValues[0]]);
                }*/
                var match = true;
                if (!ignore && options.dimFields.length > dimStartIdx) { //hierarchy case
                    currentDim.isTop = !(row[op_leafField] === 0 || fakeLeaf);
                    for (var k = dimStartIdx; k < dimUpper; k++) {
                        var dimObj = options.dimFields[k];
                        var dim = dimUINames[k];
                        var name_4 = row[dimMDXNames[k]];
                        var level_1 = row[dimMDXLevels[k]];
                        var prefix = "";
                        if (!dimObj.isAttrCol && k === 1 && options.dim2Level !== undefined && options.dim2Level >= 0) {
                            if (options.dim2Level < 9) {
                                if (options.dim2Level !== level_1)
                                    ignore = true;
                            }
                            else { //leaf only
                                if (row[dimChildNums[k]] > 0)
                                    ignore = true;
                            }
                        }
                        else {
                            if (resultInHierarchy) {
                                for (var j = 0; j < level_1; j++)
                                    prefix += "   ";
                            }
                        }
                        var fakeLeaf2 = false;
                        if (dimObj.DIM_ID === "LEVEL" && dimObj.ID === "NAME" && options.drillTo >= 0) {
                            if (level_1 === options.drillTo)
                                fakeLeaf2 = true;
                            else if (level_1 > options.drillTo)
                                ignore = true;
                        }
                        if (options.aggregateCode !== 5 || row[op_leafField] === 0)
                            currentDim[dim] = prefix + name_4;
                        var dimVal = dimMDXValues[k];
                        var code = mdxRetrieveValue(row[dimVal]);
                        var dimName = (dimObj.ID === "NAME" ? dimObj.DIM_ID : dimObj.ID);
                        currentDim["".concat(dimName, "_ID")] = code;
                        if (allCode) {
                            var field = "".concat(dimPrefixes[k], ".[CODE]");
                            currentDim[dimName + "_NAME"] += "(".concat(row[field], ")");
                        }
                        else if (options.dispAttrs && options.dispAttrs[dimName] && code) {
                            var dispAttr = options.dispAttrs[dimName];
                            var attrList = (dispAttr instanceof Array ? dispAttr : [dispAttr]);
                            for (var k_1 = 0; k_1 < attrList.length; k_1++) {
                                var attr = attrList[k_1];
                                var attrVal = '';
                                if (attr === 'DESCRIPTION') { //must be account
                                    var acct = (0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.getStore)().getters.accountIdMap[code];
                                    if (acct)
                                        attrVal = acct.DESCRIPTION;
                                }
                                else {
                                    var field = "".concat(dimPrefixes[k_1], ".[").concat(attr, "]");
                                    attrVal = row[field];
                                }
                                currentDim[dimName + "_" + attr] = attrVal;
                            }
                        }
                        currentDim.leaf = ((row[dimChildNums[k]] === 0 || fakeLeaf2) && currentDim.leaf !== false);
                        currentDim.isTop = currentDim.isTop && (level_1 === topLevels[k]);
                        if (!prevDim || prevDim[dim] !== currentDim[dim])
                            match = false;
                        if (dimObj.isAttrCol && row[dimMDXLevels[k]] === 0)
                            ignore = true;
                    }
                }
                var skipLevel = false;
                if (resultInHierarchy) {
                    skipLevel = ((options.aggregateCode === 2 && level > 0) || (options.aggregateCode === 6 && level === 0) || options.aggregateCode === 3 || (options.aggregateCode === 5 && !currentDim.isTop));
                    currentDim.leaf = ((row[op_leafField] === 0 || fakeLeaf) && currentDim.leaf !== false);
                    var acctId = (currentDim["ACCOUNT_ID"] || node["ACCOUNT_ID"]);
                    var thisAcct = accountMap[acctId];
                    if (!skipLevel && acctId && thisAcct && thisAcct.DISABLE_ROLLUP)
                        skipLevel = true;
                }
                var skipRow = false;
                if (!ignore && ((!skipLevel && !options.leafOnly) || currentDim.leaf !== false)) {
                    if (!resultInHierarchy || row[op_leafField] === 0) {
                        if (!prevDim) {
                            valueNode = objectAssign(node, currentDim);
                            if (!resultInHierarchy)
                                siblings.push(valueNode);
                        }
                        else if (!match) {
                            valueNode = objectAssign({}, currentDim);
                            siblings.push(valueNode);
                        }
                    }
                    else {
                        if (!prevDim) {
                            //valueNode = objectAssign({group: Vue.i18n.translate("total_of", {field: node.group})}, currentDim);
                            //node.children.push(valueNode);	
                            valueNode = objectAssign(node, currentDim);
                            //node.children.rollup++;
                        }
                        else if (!match) {
                            valueNode = objectAssign({}, currentDim);
                            node.children.push(valueNode);
                            //node.children.rollup++;
                        }
                    }
                    if (ddByDate /*&& options.dateField==="MONTH"*/ && noteRoot) {
                        var current = noteRoot;
                        for (var j = 0; j < dimUpper; j++) {
                            //if(options.dimFields[j].ID==="ID" || options.dimFields[j].ID==="NAME") {
                            var value = mdxRetrieveValue(row[dimMDXValues[j]]);
                            current = current[value];
                            if (!current)
                                break;
                            //}
                        }
                        if (current) {
                            var notes = {};
                            for (var dateField in current) {
                                /*if(multiVersion) { //one query only access one version
                                    const fieldVal: string = dateField+"-v"+majorVersionID;
                                    notes[fieldVal] = current[dateField];
                                } else */ if (useMeasures && !options.withCompTotal) {
                                    for (var mID in current[dateField]) {
                                        var fieldVal_1 = dateField + "-m" + mID;
                                        notes[fieldVal_1] = current[dateField][mID];
                                    }
                                }
                                else {
                                    var fieldVal_2 = dateField;
                                    notes[fieldVal_2] = current[dateField];
                                }
                            }
                            valueNode.notes = notes;
                        }
                    }
                    if ((drilldownToBottom || (options.drilldown && options.leafOnly)) && enableDatalock && dataLockRoot) {
                        var current = dataLockRoot;
                        for (var j = 0; j < dimUpper; j++) {
                            //if(options.dimFields[j].ID==="ID" || options.dimFields[j].ID==="NAME") {
                            var value = mdxRetrieveValue(row[dimMDXValues[j]]);
                            current = current[value] || current['ALL'];
                            if (!current)
                                break;
                            //}
                        }
                        if (current) {
                            var locks = {};
                            for (var dateField in current) {
                                /*if(multiVersion) {
                                    const fieldVal: string = dateField+"-v"+majorVersionID;
                                    locks[fieldVal] = current[dateField];
                                } else*/ if (useMeasures && !options.withCompTotal) {
                                    for (var mID in current[dateField]) {
                                        var fieldVal_3 = dateField + "-m" + mID;
                                        locks[fieldVal_3] = current[dateField][mID];
                                    }
                                }
                                else {
                                    var fieldVal_4 = dateField;
                                    locks[fieldVal_4] = current[dateField];
                                }
                            }
                            valueNode.locks = locks;
                        }
                    }
                    prevDim = currentDim;
                }
                else {
                    skipRow = true;
                    valueNode = {}; //not used
                }
                var ordinal = void 0, fieldVal = void 0;
                //if(ddByDate) {
                var upperOrdinal_1 = (row.TUPLE_ORDINAL + 1) * timeCoordinates;
                var timeIdx = void 0, timeVal = void 0;
                var hasValue = false;
                valueNode._undefined = _undefined;
                if (splitOtherVersion)
                    valueNode.otherVersionData = {};
                for (; cellIdx < cells.length && (ordinal = cells[cellIdx].ORDINAL) < upperOrdinal_1; cellIdx++) {
                    if (skipRow)
                        continue;
                    timeIdx = ordinal % timeCoordinates;
                    if (ddByDate && timeAxis[timeIdx]["[Time].[Time].[LEVEL_NUMBER]"] === 0 && timeAxis[timeIdx]["[Time].[Time].[MEMBER_CAPTION]"] === '(all)')
                        continue;
                    hasValue = true;
                    if (multiOnColDims) {
                        fieldVal = fieldList[timeIdx];
                    }
                    else {
                        timeVal = (ddByDate ? timeAxis[timeIdx]["[Time].[Time].[MEMBER_CAPTION]"] : mdxRetrieveValue(timeAxis[timeIdx][timeUnField]));
                        fieldVal = "date-" + timeVal;
                    }
                    /*if(actualAndPlanDataHasOverLap && !drilldownToBottom) {
                        if(timeAxis[timeIdx].versionNo==calcViewModel.actualRoot.RESULT_NODE) { //compare string with number, so use ==
                            if(timeVal<actualAndPlanDataCutoffDate) valueNode[fieldVal] = cells[cellIdx].FORMATTED_VALUE;
                        } else {
                            if(timeVal>=actualAndPlanDataCutoffDate) valueNode[fieldVal] = cells[cellIdx].FORMATTED_VALUE;
                        }
                    } else {*/
                    if (measureResult) {
                        if (timeAxis[timeIdx].isInit)
                            fieldVal = fieldVal + "-mb" + timeAxis[timeIdx].measureID;
                        else {
                            if (!options.withCompTotal)
                                fieldVal = fieldVal + "-m" + timeAxis[timeIdx].measureID;
                            else {
                                if (compTotalMeasureIDs.has('' + timeAxis[timeIdx].measureID)) {
                                    if (timeAxis[timeIdx][timeLevelField] === 1)
                                        fieldVal = "date-m" + timeAxis[timeIdx].measureID;
                                    else
                                        continue;
                                }
                            }
                        }
                    }
                    if (splitOtherVersion /* && timeAxis[timeIdx].versionNo!=majorVersionID*/) {
                        valueNode.otherVersionData[fieldVal] = cells[cellIdx].FORMATTED_VALUE;
                        continue;
                    }
                    valueNode[fieldVal] = cells[cellIdx].FORMATTED_VALUE;
                    //}
                }
                if (!drilldownToBottom && !options.showEmpty)
                    valueNode.hidden = !hasValue && !valueNode.notes;
                /*} else {
                    for(; cellIdx<cells.length && (ordinal=cells[cellIdx].ORDINAL)<=row.TUPLE_ORDINAL; cellIdx++) {
                        fieldVal = "date-"+row[dfField];
                        if(multiVersion) {
                            const versionVal = row["[Version].[Version].[MEMBER_UNIQUE_NAME]"];
                            fieldVal=fieldVal+"-v"+mdxRetrieveValue(versionVal);
                        }
                        valueNode[fieldVal] = cells[cellIdx].FORMATTED_VALUE;
                    }
                }*/
                if (resultInHierarchy)
                    prevCode = row[op_codeField];
            }
            catch (ex) {
                console.log(ex);
            }
        }
        //console.log(JSON.stringify(result));
        return { rowData: result, dateFieldList: dateFieldList, colFields: colFields, axis0List: axis0List, drilldownToBottom: drilldownToBottom, allDimExpanded: allDimExpanded };
    }
    function preprocessQueryObj(queryObj) {
        if (queryObj.dateRange.nameSets)
            queryObj.dateRange.nameSets = queryObj.dateRange.nameSets.filter(function (n) { return !isNaN(n); });
        if (dateOnCol && (options.showHalfYear || options.showDateRangeTotal)) {
            var rangeValues = queryObj.dateRange.dateRange.values;
            if (queryObj.dateRange.customRange.values) {
                if (queryObj.dateRange.customRange.values[0] > rangeValues[0])
                    rangeValues[0] = queryObj.dateRange.customRange.values[0];
                if (queryObj.dateRange.customRange.values[1] < rangeValues[1])
                    rangeValues[1] = queryObj.dateRange.customRange.values[1];
            }
            if (options.showHalfYear) {
                var y1 = parseInt(rangeValues[0].substring(0, 4));
                var m1 = parseInt(rangeValues[0].substring(5));
                var y2 = parseInt(rangeValues[1].substring(0, 4));
                var m2 = parseInt(rangeValues[1].substring(5));
                var halfYears = [];
                if (y1 === y2) {
                    if (m1 <= 6)
                        halfYears.push("$" + y1 + "_H1$");
                    if (m2 > 6)
                        halfYears.push("$" + y1 + "_H2$");
                }
                else {
                    if (m1 <= 6)
                        halfYears.push("$" + y1 + "_H1$");
                    halfYears.push("$" + y1 + "_H2$");
                    for (var i = y1 + 1; i < y2; i++) {
                        halfYears.push("$" + i + "_H1$");
                        halfYears.push("$" + i + "_H2$");
                    }
                    halfYears.push("$" + y2 + "_H1$");
                    if (m2 > 6)
                        halfYears.push("$" + y2 + "_H2$");
                }
                if (halfYears.length > 0) {
                    var ns = queryObj.dateRange.nameSets || [];
                    ns = ns.concat(halfYears);
                    queryObj.dateRange.nameSets = ns;
                }
            }
            if (options.showDateRangeTotal) {
                var ns = queryObj.dateRange.nameSets || [];
                if (options.enablePeriodCompare) {
                    var originDataRange = getDateParam(selectedVersions, options.dateField, options.dateRange);
                    var originRangeValues = originDataRange.customRange.values;
                    ns.push("$RANGE(" + originRangeValues[0] + ":" + originRangeValues[1] + ")$");
                    var unit = options.periodCompareShift[0];
                    var shift = parseInt(options.periodCompareShift.substring(1));
                    if (unit === 'y')
                        shift = shift * 12;
                    else if (unit === 'q')
                        shift = shift * 4;
                    var r1 = (0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.getMonthAfter)(originRangeValues[0], shift);
                    var r2 = (0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.getMonthAfter)(originRangeValues[1], shift);
                    ns.push("$RANGE2(" + r1 + ":" + r2 + ")$");
                }
                else
                    ns.push("$RANGE(" + rangeValues[0] + ":" + rangeValues[1] + ")$");
                queryObj.dateRange.nameSets = ns;
            }
        }
    }
    function getDataPromise(queryObj) {
        preprocessQueryObj(queryObj);
        var rawDataMDXPromise = $.post({
            url: "/hdb/mdxGetSheetData",
            data: JSON.stringify(queryObj),
            processData: true,
            contentType: "application/json",
            headers: {
                "Accept": "application/json"
            },
        }).then(function (data) {
            if (options.toSheet)
                return;
            if (data.cell && data.cell.length > max_rows * 100)
                throw new _ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.EPM2Error(true, VueApp.i18n.translate("too_many_rows"));
            return data;
        });
        return rawDataMDXPromise;
    }
    function getNotePromise(queryObj) {
        var multiVersion = false; //(queryObj.versionNOs.length>1);
        var cellNotePromise = Promise.resolve($.post({
            url: "/hdb/getNotes",
            data: JSON.stringify(queryObj),
            dataType: "json",
            processData: true,
            contentType: "application/json",
            headers: {
                "Accept": "application/json"
            },
        }));
        var sheetNotePromise = Promise.resolve($.post({
            url: "/hdb/getNotes/SHEET_NOTE",
            data: JSON.stringify(queryObj),
            dataType: "json",
            processData: true,
            contentType: "application/json",
            headers: {
                "Accept": "application/json"
            },
        }));
        var notePromise = Promise.all([cellNotePromise, sheetNotePromise]).then(function (_a) {
            var inp1 = _a[0], inp2 = _a[1];
            var input = [].concat(inp2, inp1); //show sheet note first
            var root = {};
            for (var i = 0; i < input.length; i++) {
                var row = input[i];
                var current = root;
                for (var j = 0; j < options.dimFields.length; j++) {
                    //if(options.dimFields[j].ID==="ID" || options.dimFields[j].ID==="NAME") {
                    var attr = options.dimFields[j].ID;
                    var dim = options.dimFields[j].DIM_ID;
                    var field = (attr === "NAME" || attr === "ID") ? dim + "_ID" : attr + "_ID";
                    var dimValue = row[field];
                    if (!current[dimValue])
                        current[dimValue] = {};
                    current = current[dimValue];
                    //}
                }
                var dateField = row['TIME_COL'] || options.dateField;
                var dateValue = "date-" + row[dateField];
                if (multiVersion) {
                    if (!current[dateValue])
                        current[dateValue] = {};
                    if (!current[dateValue][row.VERSION_ID])
                        current[dateValue][row.VERSION_ID] = [getNoteContent(row)];
                    else
                        current[dateValue][row.VERSION_ID].push(getNoteContent(row));
                }
                else if (useMeasures) {
                    if (options.withCompTotal) {
                        if (!compTotalMeasureIDs.has('' + row.MEASURE_ID)) {
                            if (!current[dateValue])
                                current[dateValue] = [getNoteContent(row)];
                            else
                                current[dateValue].push(getNoteContent(row));
                        }
                    }
                    else {
                        if (!current[dateValue])
                            current[dateValue] = {};
                        if (!current[dateValue][row.MEASURE_ID])
                            current[dateValue][row.MEASURE_ID] = [getNoteContent(row)];
                        else
                            current[dateValue][row.MEASURE_ID].push(getNoteContent(row));
                    }
                }
                else if (multiOnColDims) {
                    var fieldVal = "date";
                    for (var i_1 = 0; i_1 < options.onColDims.length; i_1++) {
                        var field = options.onColDims[i_1];
                        var col = void 0;
                        if (field.DIM_ID === "DATE")
                            col = field.ID;
                        else if (field.ID === "NAME")
                            col = field.DIM_ID + "_ID";
                        else
                            col = field.ID + "_ID";
                        fieldVal = fieldVal + "-d[" + row[col] + "]";
                    }
                    if (!current[fieldVal])
                        current[fieldVal] = [getNoteContent(row)];
                    else
                        current[fieldVal].push(getNoteContent(row));
                }
                else {
                    if (!current[dateValue])
                        current[dateValue] = [getNoteContent(row)];
                    else
                        current[dateValue].push(getNoteContent(row));
                }
            }
            //console.log(JSON.stringify(root));
            return root;
        }).catch(function (reason) {
            console.error(reason);
            return null;
        });
        return notePromise;
    }
    function getDataLockPromise(queryObj) {
        var dataLockPromise = $.post({
            url: "/hdb/getDataLock",
            data: JSON.stringify(queryObj),
            processData: true,
            contentType: "application/json",
            headers: {
                "Accept": "application/json"
            },
        }).then(function (data) {
            if (!data || !data.records)
                return {};
            var input = data.records;
            var root = {};
            for (var i = 0; i < input.length; i++) {
                var row = input[i];
                var current = root;
                for (var j = 0; j < options.dimFields.length; j++) {
                    //if(options.dimFields[j].ID==="ID" || options.dimFields[j].ID==="NAME") {
                    var attr = options.dimFields[j].ID;
                    var dim = options.dimFields[j].DIM_ID;
                    var field = (attr === "NAME" || attr === "ID") ? dim + "_ID" : attr + "_ID";
                    var dimValue = row[field] || "ALL";
                    if (!current[dimValue])
                        current[dimValue] = {};
                    current = current[dimValue];
                    //}
                }
                var dateField = 'TIME_ID';
                var dateValue = "date-" + row[dateField];
                if (multiVersion) {
                    if (!current[dateValue])
                        current[dateValue] = {};
                    current[dateValue][row.VERSION_ID] = row.STATUS;
                }
                else if (useMeasures) {
                    if (options.withCompTotal) {
                        if (!compTotalMeasureIDs.has('' + row.MEASURE_ID))
                            current[dateValue] = row.STATUS;
                    }
                    else {
                        if (!current[dateValue])
                            current[dateValue] = {};
                        current[dateValue][row.MEASURE_ID] = row.STATUS;
                    }
                }
                else
                    current[dateValue] = row.STATUS;
            }
            //console.log(JSON.stringify(root));
            return root;
        });
        return dataLockPromise;
    }
    function filterDateRange(result) {
        var range = getCustomRangePeriod(options.dateRange);
        if (!range)
            return result;
        var period = range.map(function (d) { return d.substring(0, 7); });
        var dateFieldList = result.dateFieldList;
        var newValues = [];
        var inRange = false, outOfRange = false;
        ;
        for (var j = 0; j < dateFieldList.length; j++) {
            var dateEntry = dateFieldList[j];
            if (!outOfRange && !inRange && dateEntry.level === 3 && dateEntry.value >= period[0])
                inRange = true;
            if (inRange && dateEntry.level === 3 && dateEntry.value > period[1]) {
                inRange = false;
                outOfRange = true;
            }
            if (inRange)
                newValues.push(dateEntry);
        }
        result.dateFieldList = newValues;
        return result;
    }
    function filterUndefined(result) {
        var rowList = result.rowData;
        result.rowData = rowList.filter(function (n) { return (!n._undefined); });
        return result;
    }
}
function getDimHierarchy(dim, calcViewModel) {
    var hierarchy = dim;
    if (dim === "Account" && calcViewModel.accountHierarchy)
        hierarchy = calcViewModel.accountHierarchy;
    else if (dim === "Level" && calcViewModel.levelHierarchy)
        hierarchy = calcViewModel.levelHierarchy;
    return hierarchy;
}
function getBranches(values, oldRowData, dimID, preview) {
    if (preview === void 0) { preview = false; }
    var newRowData = [];
    function checkRootNode(node) {
        var nodeId = parseInt(node[dimID]);
        if (values.indexOf(nodeId) >= 0) {
            newRowData.push(node);
            return { check: false, children: null };
        }
        else if (preview) { //topdown mode, need to mark parent row not in filter
            node.notInFilter = true;
        }
        return { check: false, children: node.children };
    }
    oldRowData.forEach(function (root) { return (0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.treeDFSTravers)(root, checkRootNode); });
    return newRowData;
}
function convertToNewTreeData(result) {
    var _id = 0;
    var hierarchyData = result.rowData;
    var rowList = [];
    var addPath = function (node) {
        rowList.push(node);
        if (node.children) {
            var prevNode = void 0;
            for (var i = 0; i < node.children.length; i++) {
                var cnode = node.children[i];
                if (cnode.groupId)
                    prevNode = cnode;
                if (cnode.firstDimLeaf && cnode !== prevNode && prevNode)
                    cnode.path = prevNode.path.concat(["_tempId_" + (_id++)]);
                else
                    cnode.path = node.path.concat([toPath(cnode.groupId)]);
            }
        }
        return { check: false, children: node.children };
    };
    hierarchyData.forEach(function (n) {
        n.path = [toPath(n.groupId)];
        (0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.treeDFSTravers)(n, addPath);
    });
    result.rowData = rowList;
    return result;
    function toPath(groupId) {
        if (!groupId || groupId === "-1")
            return "_tempId_" + (_id++);
        else
            return groupId;
    }
}
function getLeafOnly(options, result) {
    var originData = result.rowData;
    var _id = 0;
    var rowList = originData.filter(function (node) { return node.leaf; });
    var dimName = options.dimFields[0].ID === "NAME" ? options.dimFields[0].DIM_ID : options.dimFields[0].ID;
    rowList.forEach(function (node) {
        node.path = ["_tempId_" + (_id++)];
        if (options.dimFields.length > 1)
            node.group = node[dimName + "_NAME"];
    });
    result.rowData = rowList;
    return result;
}
function merge(left, right, sortCols) {
    var result = [];
    var il = 0, ir = 0;
    while (il < left.length && ir < right.length) {
        if (compare(left[il], right[ir]) < 0) {
            result.push(left[il++]);
        }
        else {
            result.push(right[ir++]);
        }
    }
    return result.concat(left.slice(il)).concat(right.slice(ir));
    function compare(lv, rv) {
        for (var i = 0; i < sortCols.length; i++) {
            if (lv[sortCols[i]] < rv[sortCols[i]])
                return -1;
            else if (lv[sortCols[i]] > rv[sortCols[i]])
                return 1;
        }
        return 0;
    }
}
function buildBlankRows(dims /*, dt*/) {
    var rowNum = dims.reduce((function (result, dim) { return (result * dim.values.length); }), 1);
    if (rowNum > max_rows)
        return -1;
    var list = dims; //.concat([{field:"ACCOUNT", values:kfs}]);
    var idxList = list.map(function (x) { return 0; });
    var path = {};
    var result = [];
    //const root = {};
    //const rootPath = [root];
    //let current = root; 
    var currentStep = 0;
    while (currentStep >= 0) {
        while (currentStep < idxList.length - 1) {
            var currentVal = list[currentStep].values[idxList[currentStep]];
            objectAssign(path, currentVal);
            currentStep++;
            //const parent = current;
            //current = {};
            //parent[currentVal] = current;
            //rootPath.push(current);
        }
        while (idxList[currentStep] < list[currentStep].values.length) {
            var currentVal = list[currentStep].values[idxList[currentStep]];
            objectAssign(path, currentVal);
            result.push(objectAssign({}, path));
            idxList[currentStep]++;
            //const dtNode = {};
            //dt.forEach(d => (dtNode[d]=0));
            //current[currentVal] = dtNode;
        }
        do {
            idxList[currentStep] = 0;
            currentStep--;
            //rootPath.pop();
            //current = rootPath[rootPath.length-1];
        } while (currentStep >= 0 && idxList[currentStep] >= list[currentStep].values.length - 1);
        if (currentStep >= 0)
            idxList[currentStep]++;
    }
    //return {rows: result, node: root};
    return result;
}
function getDateParam(versions, field, customRange) {
    var startOp = null, endOp = null;
    var today = new Date();
    var year = today.getFullYear();
    var defaultStartOp = "" + (year - 1) + "-01-01";
    var defaultEndOp = "" + (year + 5) + "-12-31";
    var startValues = [], endValues = [];
    for (var i = 0; i < versions.length; i++) {
        if (versions[i].OP_START)
            startValues.push(versions[i].OP_START);
        else if (versions[i].VERSION_TYPE === "Actual")
            startValues.push(defaultStartOp);
        if (versions[i].OP_END)
            endValues.push(versions[i].OP_END);
    }
    if (startValues.length > 0)
        startOp = startValues.reduce((function (min, d) { return (min < d ? min : d); }), "9999-99-99");
    if (endValues.length > 0)
        endOp = endValues.reduce((function (max, d) { return (max > d ? max : d); }), "0000-00-00");
    if (!startOp)
        startOp = defaultStartOp;
    if (!endOp)
        endOp = defaultEndOp;
    var startOpM = startOp.substring(0, 7);
    var endOpM = endOp.substring(0, 7);
    var dateRange = { field: "MONTH", values: [startOpM, endOpM] };
    var custRange = getCustomRangePeriod(customRange);
    if (custRange) {
        custRange = custRange.map(function (d) { return d.substring(0, 7); });
        if (custRange[0] > custRange[1])
            return { epmError: 1 };
        if (custRange[0] > endOpM || custRange[1] < startOpM)
            return { epmError: 2 };
    }
    return { field: field, dateRange: dateRange, customRange: { field: "MONTH", values: custRange } };
}
function getDatePeriod(versions, customRange) {
    var param = getDateParam(versions, null, customRange);
    if (param.epmError)
        return param;
    var _a = param.dateRange.values, startOp = _a[0], endOp = _a[1];
    if (param.customRange.values) {
        var _b = param.customRange.values, custStartOp = _b[0], custEndOp = _b[1];
        if (custStartOp > startOp)
            startOp = custStartOp;
        if (custEndOp < endOp)
            endOp = custEndOp;
    }
    var startMonth = startOp.substring(0, 7);
    var endMonth = endOp.substring(0, 7);
    return [startMonth, endMonth];
}
function getCustomRangePeriod(customRange) {
    function getLastDateOfMonth(y, m) {
        var d = new Date();
        d.setFullYear(y, m, 0);
        return "".concat(y, "-").concat((m < 10 ? "0" + m : m), "-").concat(d.getDate());
    }
    if (!customRange || !customRange.values)
        return null;
    customRange.values = customRange.values.filter(function (v) { return !!v; });
    if (customRange.values.length === 0)
        return null;
    if (customRange.field === "DATE") {
        if (customRange.values.length === 1) {
            return [customRange.values[0], customRange.values[0]];
        }
        else {
            return customRange.values;
        }
    }
    else if (customRange.field === "MONTH") {
        var val1 = customRange.values[0] + "-01";
        var endDate = (customRange.values.length === 1 ? customRange.values[0] : customRange.values[1]);
        var parts = endDate.split("-");
        var val2 = getLastDateOfMonth(parseInt(parts[0]), parseInt(parts[1]));
        return [val1, val2];
    }
    else if (customRange.field === "QUARTER") {
        var fiscStart = fiscal_year_start === null ? 1 : parseInt(fiscal_year_start);
        var parts1 = customRange.values[0].split("-");
        var y1 = parseInt(parts1[0]);
        var fy1 = y1;
        var q1 = parseInt(parts1[1].substring(1));
        var m1 = (q1 - 1) * 3 + fiscStart;
        if (m1 > 12) {
            m1 = m1 - 12;
            fy1 = fy1 + 1;
        }
        var val1 = "".concat(fy1, "-").concat((m1 < 10 ? "0" + m1 : m1), "-01");
        var y2 = void 0, q2 = void 0, m2 = void 0;
        if (customRange.values.length === 1) {
            y2 = y1;
            m2 = q1 * 3 + fiscStart - 1;
            if (m2 > 12) {
                m2 = m2 - 12;
                y2 = y2 + 1;
            }
        }
        else {
            var parts2 = customRange.values[1].split("-");
            y2 = parseInt(parts2[0]);
            q2 = parseInt(parts2[1].substring(1));
            m2 = q2 * 3 + fiscStart - 1;
            if (m2 > 12) {
                m2 = m2 - 12;
                y2 = y2 + 1;
            }
        }
        var val2 = getLastDateOfMonth(y2, m2);
        return [val1, val2];
    }
    else if (customRange.field === "YEAR") {
        var fiscStart = fiscal_year_start === null ? 1 : parseInt(fiscal_year_start);
        var y1 = parseInt(customRange.values[0]);
        var m1 = fiscStart;
        var val1 = "".concat(y1, "-").concat((m1 < 10 ? "0" + m1 : m1), "-01");
        var y2 = (customRange.values.length === 1 ? y1 : parseInt(customRange.values[1]));
        var m2 = fiscStart - 1;
        if (m2 > 0)
            y2 = y2 + 1;
        else
            m2 = 12;
        var val2 = getLastDateOfMonth(y2, m2);
        return [val1, val2];
    }
    return null;
}
function getDateRange(versions, field, customRange) {
    var param = getDateParam(versions, field, customRange);
    if (param.epmError)
        return Promise.reject(param);
    param.field = "MONTH";
    return Promise.resolve($.post({
        url: '/hdb/getTimeValue',
        data: JSON.stringify(param),
        processData: true,
        contentType: "application/json",
        headers: {
            "Accept": "application/json"
        },
    }).then(function (rawdata) {
        var result = rawdata.map(function (d) { return (d["MONTH"]); });
        result.sort();
        var monthList = result.map(function (m) { return ({ DATE: m, DATE_NAME: (0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.formatDate)(m, 3) }); });
        var currentMonth = (0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.getCutoffDate)('MONTH');
        if (monthList[0].DATE <= currentMonth && monthList[monthList.length - 1].DATE >= currentMonth)
            monthList = [{ DATE: "currentMonth", DATE_NAME: VueApp.i18n.translate('current_month') }].concat(monthList);
        var allList = { "MONTH": [], "QUARTER": [], "YEAR": [] };
        if (field === "MONTH")
            return monthList;
        else {
            var fiscStart = fiscal_year_start === null ? 1 : parseInt(fiscal_year_start);
            var fiscMonth = fiscStart - 1;
            if (field === "QUARTER" || field === "ALL") {
                var newResult = [];
                var qIndex = [];
                for (var i = 0; i < 12; i++) {
                    var dist = (i >= fiscMonth ? i : i + 12);
                    qIndex.push(Math.floor((dist - fiscMonth) / 3) + 1);
                }
                var preQuarter = -1;
                for (var i = 0; i < result.length; i++) {
                    var year = parseInt(result[i].substring(0, 4));
                    var month = parseInt(result[i].substring(5)) - 1;
                    var quarter = qIndex[month];
                    if (quarter !== preQuarter) {
                        preQuarter = quarter;
                        var y = (month < fiscMonth ? year - 1 : year);
                        var qStr = "" + y + "-Q" + quarter;
                        newResult.push({ DATE: qStr, DATE_NAME: (0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.formatDate)(qStr, 2) });
                    }
                }
                if (field === "ALL")
                    allList["QUARTER"] = newResult;
                else
                    return newResult;
            }
            if (field === "YEAR" || field === "ALL") {
                var newResult = [];
                var preYear = -1;
                for (var i = 0; i < result.length; i++) {
                    var year = parseInt(result[i].substring(0, 4));
                    var month = parseInt(result[i].substring(5)) - 1;
                    var y = (month < fiscMonth ? year - 1 : year);
                    if (y !== preYear) {
                        preYear = y;
                        var yStr = "" + y;
                        newResult.push({ DATE: yStr, DATE_NAME: (0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.formatDate)(yStr, 1) });
                    }
                }
                if (field === "ALL")
                    allList["YEAR"] = newResult;
                else
                    return newResult;
            }
            allList["MONTH"] = monthList;
            return allList;
        }
    }));
}
function buildBlankSheet(options, calcViewModel, preview) {
    if (options.dateRange && options.dateRange.values)
        options.dateRange.values = options.dateRange.values.map(function (d) { return (d === 'currentMonth' ? (0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.getCutoffDate)('MONTH') : d); });
    var filters = options.filters, dateRange = options.dateRange;
    var version = options.versions[0]; //there must be single version for data enter
    var versionNo = version.RESULT_NODE;
    var versions = options.versions;
    var levelHierarchy = true;
    var acctHierarchy = false;
    var useMeasures = (calcViewModel.measures && calcViewModel.measures.length > 0);
    if (calcViewModel.type === 3)
        options.aggregateCode = 4;
    var dimsWithRel = {}; //for inputOnlt relationship has to append filters
    var resultPromise = new Promise(function (resolve, reject) {
        var originDimList = calcViewModel.dimList.slice(1); //0 always be LEVEL_ID
        var dimList = originDimList.filter(function (dim) { return (dim.ID !== "ACCOUNT"); }); //handle account later
        var dateFilterPromise = getDateRange(versions, options.accountTime, dateRange).then(function (dateList) {
            dateList = dateList.filter(function (d) { return (d.DATE !== "currentMonth"); });
            if (!calcViewModel.dateMandatory && options.nameSetSelect && options.nameSetSelect.length > 0) {
                return dateList.concat(options.nameSetSelect.map(function (ns) { return ({ DATE: ns, DATE_NAME: ns, readOnly: true }); }));
            }
            else
                return dateList;
        });
        if (dateFilterPromise.epmError)
            return reject({ epmError: true, errorCode: dateFilterPromise.epmError });
        var colDimPromise = dateFilterPromise;
        var dimFilterPromises = null, hierarchyPromise = null, newDimList = null;
        if (!calcViewModel.rowInput) {
            dimFilterPromises = [];
            newDimList = [];
            var startIdx = 0;
            if (calcViewModel.rowDims[0].hierarchy) {
                if (calcViewModel.rowDims[0].code !== "LEVEL")
                    levelHierarchy = false;
                if (calcViewModel.rowDims[0].code === "ACCOUNT")
                    acctHierarchy = true;
                hierarchyPromise = getHierarchy(calcViewModel.rowDims[0]);
                startIdx = 1;
            }
            for (var i = startIdx; i < calcViewModel.rowDims.length; i++) {
                var dim = calcViewModel.rowDims[i];
                var newPromise = void 0, newDim = void 0;
                if (dim.code === "DATE") {
                    newPromise = dateFilterPromise.then(function (dateList) {
                        return { field: "DATE", values: dateList };
                    });
                    newDim = { ID: "DATE" };
                }
                else {
                    newDim = (dim.code === "ACCOUNT" ? { ID: "ACCOUNT", ishierarchy: true } : calcViewModel.dimMap[dim.code]);
                    newPromise = getDimValues(newDim);
                }
                newDimList.push(newDim);
                dimFilterPromises.push(newPromise);
            }
        }
        var colField = calcViewModel.colDims[0].code;
        if (colField === "ACCOUNT") {
            var acctDim = calcViewModel.dimMap["ACCOUNT"];
            if (!acctDim)
                acctDim = { ID: "ACCOUNT", ishierarchy: true };
            colDimPromise = getDimValues(acctDim);
        }
        else if (colField === "DATE") {
            colDimPromise = dateFilterPromise.then(function (dateList) {
                return { field: "DATE", values: dateList };
            });
        }
        else {
            var colDim = calcViewModel.dimMap[colField];
            colDimPromise = getDimValues(colDim);
        }
        colDimPromise = Promise.resolve(colDimPromise).catch(function (err) {
            reject(VueApp.i18n.translate("no_dim_val"));
        });
        var axisDims = [].concat(calcViewModel.rowDims, calcViewModel.colDims);
        var axisRelPromises = axisDims.map(function (d) { return dimsWithRel[d.code]; }).filter(function (d) { return !!d; });
        var oldValuePromise;
        if (axisRelPromises.length > 0) {
            oldValuePromise = Promise.all(axisRelPromises).then(function (results) {
                return getOldValues(calcViewModel.allDimList, results);
            });
        }
        else
            oldValuePromise = getOldValues(calcViewModel.allDimList);
        Promise.all([oldValuePromise, colDimPromise]).then(function (_a) {
            var oldValue = _a[0], dates = _a[1];
            var dateFieldList = dates;
            if (!dateFieldList || dateFieldList.length === 0) {
                reject(VueApp.i18n.translate("date_range_not_match"));
                return;
            }
            if (calcViewModel.inputOnly && calcViewModel.rowInput) {
                if (oldValue.note) {
                    for (var i = 0; i < oldValue.value.length; i++) {
                        var row = oldValue.value[i];
                        var noteData = oldValue.note;
                        for (var j = 0; j < calcViewModel.rowDims.length; j++) {
                            var field = calcViewModel.rowDims[j].code;
                            noteData = noteData[row[field]];
                            if (!noteData)
                                break;
                        }
                        if (noteData)
                            row.notes = noteData;
                    }
                }
                return resolve({ rowData: oldValue.value, dateFieldList: dateFieldList, formularList: oldValue.formularList });
            }
            var dtObj = {};
            Promise.all(dimFilterPromises).then(function (results) {
                for (var i = 0; i < results.length; i++) {
                    if (!results[i].values || results[i].values.length === 0) {
                        return reject(VueApp.i18n.translate("no_data_dim", { dim: newDimList[i].ID }));
                    }
                }
                var rows = (results && results.length > 0 ? buildBlankRows(results /*, kfList, dates*/) : null);
                if (rows === -1)
                    return reject(VueApp.i18n.translate("too_many_rows"));
                var prefix = dates.field;
                if (hierarchyPromise) {
                    hierarchyPromise.then(function (data) {
                        var leafNum = (0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.getLeafNodes)(data).length;
                        if (leafNum * (rows ? rows.length : 1) > max_rows)
                            return reject(VueApp.i18n.translate("too_many_rows"));
                        if (calcViewModel.type === 3) {
                            var assignValue = function (node) {
                                var entry = oldValue.value[node.RESULT_NODE];
                                if (entry)
                                    objectAssign(node, entry);
                                node._level = node.RESULT_NODE;
                                node.leaf = !!node.IS_LEAF;
                                return { check: false, children: node.children };
                            };
                            (0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.treeDFSTravers)(data[0], assignValue);
                            return resolve({ rowData: data, dateFieldList: dateFieldList });
                        }
                        var root = { children: data };
                        var children, group, parent;
                        var current = root;
                        while (current) {
                            children = current.children;
                            parent = current;
                            group = current.RESULT_NODE;
                            //const val =  current.group;
                            //removes this item from the linked list
                            current = current.next;
                            if (children.length === 0) {
                                //nodeResult[val] = jQuery.extend(true, {}, node);
                                var root_1 = oldValue.value[group];
                                var noteRoot = (oldValue.note ? oldValue.note[group] : null);
                                var dataLockRoot = (oldValue.dataLock ? oldValue.dataLock[group] : null);
                                combineDimDates(rows, dtObj, parent, root_1, newDimList, noteRoot, dataLockRoot, prefix);
                            }
                            else {
                                for (var i = children.length - 1; i >= 0; i--) {
                                    var child = children[i];
                                    child.parent = parent;
                                    //place new item at the head of the list
                                    child.next = current;
                                    current = child;
                                }
                                var root_2 = oldValue.value[group];
                                combineDimDates(rows, dtObj, parent, root_2, newDimList, null, null, prefix);
                            }
                        }
                        return resolve({ rowData: data, dateFieldList: dateFieldList, formularList: oldValue.formularList });
                    }).catch(function (ex) {
                        console.error(ex);
                        reject(ex);
                    });
                }
                else {
                    combineDimDates(rows, dtObj, null, oldValue.value, newDimList, oldValue.note, oldValue.dataLock, prefix);
                    return resolve({ rowData: rows, dateFieldList: dateFieldList, formularList: oldValue.formularList });
                }
            }).catch(function () {
                reject(VueApp.i18n.translate("no_dim_val"));
            });
        }).catch(function (err) {
            if (err.responseText) {
                var errObj = null;
                try {
                    errObj = JSON.parse(err.responseText);
                }
                catch (e) {
                    return reject(VueApp.i18n.translate("internal_error"));
                }
                if (errObj && errObj.userFriendly)
                    return reject(errObj.message);
                else
                    return reject(VueApp.i18n.translate("internal_error"));
            }
            else
                return reject(VueApp.i18n.translate("internal_error"));
        });
    }).then(convertToNewTreeData);
    if (options.showLeafOnly)
        resultPromise = resultPromise.then(getLeafOnly.bind(null, options));
    return resultPromise;
    function getHiddenFilter(dim, filters) {
        var dimObj = calcViewModel.dimMap[dim];
        if (!dimObj)
            return;
        for (var i = 0; i < dimObj.fieldList.length; i++) {
            var field = dimObj.fieldList[i];
            if (field.hidden && field.values)
                filters.push({ code: field.ID, parent: field.DIM_ID, ishierarchy: field.ishierarchy, values: field.values.map(function (n) { return n.ID; }) });
        }
    }
    function getHierarchy(dim) {
        var hierDim = dim.code;
        var dispAttrPromise = getDimAttrValues(dim);
        var list = [];
        var relFilters = [];
        var hierFilters = [];
        if (filters && filters.length > 0) {
            for (var i = 0; i < filters.length; i++) {
                var ff = filters[i];
                if (ff.parent === hierDim) {
                    if (ff.code === "ID" || ff.code === "NAME") {
                        list = ff.values;
                    }
                    else {
                        hierFilters.push(ff);
                    }
                }
            }
            var relDims = calcViewModel.filterDims.filter(function (d) { return (d.type === "relationship" && !d.forEditable); });
            if (relDims && relDims.length > 0) {
                for (var i = 0; i < relDims.length; i++) {
                    var rel = relDims[i];
                    if (rel.dim1 === hierDim || rel.dim2 === hierDim) {
                        for (var j = 0; j < filters.length; j++) {
                            var ff = filters[j];
                            if ((ff.code === "ID" || ff.code === "NAME") && (ff.parent !== hierDim) && (ff.parent === rel.dim1 || ff.parent === rel.dim2)) {
                                relFilters.push({ relationship: rel, filter: ff });
                                break;
                            }
                        }
                    }
                }
            }
        }
        getHiddenFilter(hierDim, hierFilters);
        if (!list || list.length === 0) {
            var levels = (hierDim === "ACCOUNT" ? calcViewModel.kfList : calcViewModel.fieldMap[hierDim + "_NAME"].values);
            list = (levels ? levels.map(function (l) { return l.ID; }) : null);
        }
        var queryObj = { table: hierDim, list: list, filters: hierFilters, relationships: relFilters };
        if (hierDim === "ACCOUNT")
            queryObj.hierarchy = calcViewModel.accountHierarchy;
        else if (hierDim === "LEVEL")
            queryObj.hierarchy = calcViewModel.levelHierarchy;
        return $.post({
            url: '/hdb/getSubTree',
            data: JSON.stringify(queryObj),
            processData: true,
            contentType: "application/json",
            headers: {
                "Accept": "application/json"
            },
        }).then(function (rawdata) {
            if (!rawdata || rawdata.length === 0)
                throw new Error(VueApp.i18n.translate("no_dim_val"));
            if (!levelHierarchy)
                rawdata.forEach(function (d) { return (delete d.LEVEL_NAME); });
            if (options.ignoreUndefined)
                rawdata = rawdata.filter(function (d) { return (d.RESULT_NODE !== -1); });
            if (hierDim === "LEVEL" && options.drillTo >= 0)
                rawdata = rawdata.filter(function (d) { return (d.LEVEL <= options.drillTo); });
            if (dispAttrPromise)
                return dispAttrPromise.then(function () {
                    rawdata.forEach(function (data) { return addAttrName(dim, data, data); });
                    return rawdata;
                });
            else
                return rawdata;
        }).then(function (rawdata) {
            var values = (0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.convertHierarchy)(rawdata);
            return values;
        }).then(function (result) {
            if (options.aggregateCode === 4 && options.hierarchy) {
                var branchNodes = null, found = false;
                for (var i = 0; i < options.filters.length; i++) {
                    var ff = options.filters[i];
                    if (ff.parent === hierDim) {
                        branchNodes = ff.values;
                        found = true;
                        break;
                    }
                }
                if (!found) {
                    if (hierDim === "ACCOUNT") {
                        branchNodes = calcViewModel.accountBranchs;
                    }
                    else if (hierDim === "LEVEL") {
                        branchNodes = calcViewModel.levelBranchs;
                    }
                    else {
                        branchNodes = list;
                    }
                }
                if (branchNodes && branchNodes.length > 0) {
                    var newRowData = getBranches(branchNodes, result, "RESULT_NODE");
                    result = newRowData;
                }
                return result;
            }
            else
                return result;
        });
    }
    function combineDimDates(rows, dtObj, leaf, oldValue, dims, noteRoot, dataLockRoot, prefix) {
        if (!rows)
            rows = [{}];
        var isHierarchy = !!leaf;
        var parent = (isHierarchy ? leaf.parent : null);
        if (isHierarchy && !parent)
            return;
        var isLeaf = (isHierarchy && !!leaf.IS_LEAF);
        if (!isLeaf && ((options.aggregateCode === 2 && leaf.LEVEL > 0) || options.aggregateCode === 3))
            return;
        if (acctHierarchy && leaf.DISABLE_ROLLUP && !isLeaf)
            return;
        var childrenArray = (isLeaf ? parent.children : leaf === null || leaf === void 0 ? void 0 : leaf.children);
        var idx = (isHierarchy ? childrenArray.indexOf(leaf) : 0);
        if (isHierarchy && levelHierarchy && !singleCurrency)
            leaf.group += "(".concat(leaf.CURRENCY, ")");
        for (var i = 0; i < rows.length; i++) {
            var d = rows[i];
            var node = (isHierarchy ? objectAssign({}, d, dtObj) : objectAssign(d, dtObj));
            if (isHierarchy) {
                node["_level"] = leaf.RESULT_NODE;
                if (levelHierarchy)
                    node["CURRENCY"] = leaf.CURRENCY;
                if (acctHierarchy) {
                    node["MEASURE_TYPE"] = leaf.DISPLAY_TYPE;
                    node["ACCOUNT_CODE"] = leaf.CODE;
                }
            }
            if (oldValue) {
                var current = oldValue;
                for (var j = 0; j < dims.length; j++) {
                    var dimID = dims[j].ID;
                    var value = node[dimID];
                    current = current[value];
                    if (!current)
                        break;
                }
                if (current) {
                    for (var dt in current) {
                        var dtVal = current[dt];
                        node[prefix + "-" + dt] = dtVal;
                    }
                }
            }
            if (noteRoot) {
                var current = noteRoot;
                for (var j = 0; j < dims.length; j++) {
                    var dim = dims[j];
                    current = current[node[dim.ID]];
                    if (!current)
                        break;
                }
                if (current) {
                    node.notes = current;
                }
            }
            if (dataLockRoot) {
                var current = dataLockRoot;
                for (var j = 0; j < dims.length; j++) {
                    var dim = dims[j];
                    current = current[node[dim.ID]] || current['ALL'];
                    if (!current)
                        break;
                }
                if (current) {
                    node.locks = current;
                }
            }
            if (isHierarchy) {
                if (i === 0) {
                    leaf.leaf = isLeaf;
                    objectAssign(leaf, node);
                }
                else {
                    idx++;
                    node.RESULT_NODE = leaf.RESULT_NODE;
                    node.leaf = isLeaf;
                    childrenArray.splice(idx, 0, node);
                }
            }
            else {
                d.leaf = true;
            }
        }
    }
    function getDimAttrValues(dim) {
        var dispAttrPromise = null;
        if (dim.dispAttrs && dim.dispAttrs.length > 0) {
            dim.attrNameMap = {};
            var dispAttrPromises = [];
            var _loop_3 = function (i) {
                var attr = dim.dispAttrs[i];
                if (attr.substring(0, 2) !== "A_")
                    return "continue";
                var promise = Promise.resolve($.post({
                    url: '/hdb/getSubTree',
                    data: JSON.stringify({ table: attr }),
                    processData: true,
                    contentType: "application/json",
                    headers: {
                        "Accept": "application/json"
                    },
                })
                    .then(function (rawdata) {
                    var attrMap = (0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.buildMapFromList)(rawdata, "RESULT_NODE");
                    var udnode = attrMap[-1];
                    if (udnode && udnode.NAME === "UNDEFINED")
                        udnode.NAME = VueApp.i18n.translate("undefined");
                    dim.attrNameMap[attr] = attrMap;
                }));
                dispAttrPromises.push(promise);
            };
            for (var i = 0; i < dim.dispAttrs.length; i++) {
                _loop_3(i);
            }
            dispAttrPromise = Promise.all(dispAttrPromises);
        }
        return dispAttrPromise;
    }
    function addAttrName(dim, node, data) {
        if (dim.dispAttrs && dim.dispAttrs.length > 0) {
            for (var i = 0; i < dim.dispAttrs.length; i++) {
                var attr = dim.dispAttrs[i];
                var attrField = (attr === 'CODE' || attr === 'DESCRIPTION') ? attr : attr + "_ATTR";
                var attrVal = node[attrField];
                data[attrField] = attrVal;
                if (attr.substring(0, 2) === "A_") {
                    var attrMap = dim.attrNameMap[attr];
                    data[attr + "_ATTR_NAME"] = attrMap[attrVal].NAME;
                    data[attr + "_ATTR_CODE"] = attrMap[attrVal].CODE;
                }
                else { //local attributes
                    data[attr + "_ATTR_NAME"] = attrVal;
                    data[attr + "_ATTR_CODE"] = attrVal;
                }
            }
        }
    }
    function getDimValues(dim) {
        var dimFilter = [];
        var relFilters = [];
        var list = null;
        if (dim.ID === "ACCOUNT") {
            var found = false;
            if (filters && filters.length > 0) {
                for (var j = 0; j < filters.length; j++) {
                    if (filters[j].parent === "ACCOUNT" && filters[j].code === "ID") {
                        list = filters[j].values;
                        found = true;
                        break;
                    }
                    else if (filters[j].parent === "ACCOUNT") {
                        dimFilter.push(filters[j]);
                    }
                }
            }
            if (!found)
                list = calcViewModel.kfList.map(function (n) { return n.ID; });
        }
        else {
            var dimFields = dim.fieldList;
            for (var i = 0; i < dimFields.length; i++) {
                var field = dimFields[i];
                var found = false;
                if (filters && filters.length > 0) {
                    for (var j = 0; j < filters.length; j++) {
                        if (field.DIM_ID === filters[j].parent && field.ID === "NAME" && filters[j].code === "ID") {
                            if (dim.ishierarchy)
                                list = filters[j].values;
                            else
                                dimFilter.push(filters[j]);
                            found = true;
                            break;
                        }
                        else if (field.DIM_ID === filters[j].parent && field.ID === filters[j].code) {
                            dimFilter.push(filters[j]);
                            found = true;
                            break;
                        }
                    }
                }
                if (!found && field.values && field.values.length > 0) {
                    if (dim.ishierarchy && field.ID === "NAME")
                        list = field.values.map(function (n) { return n.ID; });
                    else {
                        if (field.ID === "NAME")
                            dimFilter.push({ code: "ID", parent: field.DIM_ID, values: field.values.map(function (n) { return n.ID; }) });
                        else
                            dimFilter.push({ code: field.ID, parent: field.DIM_ID, values: field.values });
                    }
                }
            }
            var relDims = calcViewModel.filterDims.filter(function (d) { return (d.type === "relationship" && !d.forEditable); });
            if (relDims && relDims.length > 0) {
                for (var i = 0; i < relDims.length; i++) {
                    var rel = relDims[i];
                    if (rel.dim1 === dim.ID || rel.dim2 === dim.ID) {
                        if (filters && filters.length > 0) {
                            for (var j = 0; j < filters.length; j++) {
                                var ff = filters[j];
                                if ((ff.code === "ID" || ff.code === "NAME") && (ff.parent !== dim.ID) && (ff.parent === rel.dim1 || ff.parent === rel.dim2)) {
                                    relFilters.push({ relationship: rel, filter: ff });
                                }
                            }
                        }
                    }
                }
            }
        }
        var dispAttrPromise = getDimAttrValues(dim);
        //if(dim.ishierarchy) {
        getHiddenFilter(dim.ID, dimFilter);
        var url = (dim.ID === "LEVEL" && options.drillTo >= 0) ? '/hdb/getSubTree' : '/hdb/getLeafs';
        var promise = $.post({
            url: url,
            data: JSON.stringify({ table: dim.ID, list: list, filters: dimFilter, relationships: relFilters }),
            processData: true,
            contentType: "application/json",
            headers: {
                "Accept": "application/json"
            },
        })
            .then(function (rawdata) {
            if (!rawdata || rawdata.length === 0)
                throw new Error(VueApp.i18n.translate("no_dim_val"));
            if (dispAttrPromise)
                return dispAttrPromise.then(function () { return rawdata; });
            else
                return rawdata;
        })
            .then(function (rawdata) {
            var values = [];
            for (var i = 0; i < rawdata.length; i++) {
                var node = rawdata[i];
                if (options.ignoreUndefined && node.RESULT_NODE === -1)
                    continue;
                var data = {};
                data[dim.ID] = node.RESULT_NODE;
                data[dim.ID + "_NAME"] = (node.RESULT_NODE === -1 && node.NAME === "UNDEFINED" ? VueApp.i18n.translate("undefined") : node.NAME);
                if (dim.ID === "LEVEL") {
                    if (dim.ID === "LEVEL" && options.drillTo >= 0 && options.drillTo !== node.LEVEL)
                        continue;
                    data["CURRENCY"] = node.CURRENCY;
                    if (!singleCurrency)
                        data[dim.ID + "_NAME"] += "(" + node.CURRENCY + ")";
                }
                if (dim.ID === "ACCOUNT") {
                    data["MEASURE_TYPE"] = node.DISPLAY_TYPE;
                    data["ACCOUNT_CODE"] = node.CODE;
                }
                if (dim.fieldList) {
                    for (var j = 0; j < dim.fieldList.length; j++) {
                        var attr = dim.fieldList[j];
                        if (attr.ID !== "NAME") {
                            data[dim.ID + "_" + attr.ID] = node[attr.ID + "_ATTR"];
                        }
                    }
                }
                addAttrName(dim, node, data);
                values.push(data);
            }
            return { field: dim.ID, values: values };
        });
        if (relFilters.length > 0)
            dimsWithRel[dim.ID] = promise;
        return promise;
        // } else {
        // 	return $.post({
        // 		url: '/hdb/getDimensions', 
        // 		data: JSON.stringify({action:"getRows", table:dim.ID, filter: dimFilter, withUndefined: !options.ignoreUndefined}),
        // 		processData: true,
        // 		contentType: "application/json",
        // 		headers: {
        // 			"Accept": "application/json"
        // 		},
        // 	})
        // 	.then(function(data) {
        // 		if(dispAttrPromise) return dispAttrPromise.then(function() { return data; });
        // 		else return data;
        // 	})
        // 	.then(function(data) {
        // 		let rawdata;
        // 		if(data) {
        // 			rawdata = data;
        // 			rawdata.forEach(function(data: any){
        // 				data[dim.ID] = data.ID;
        // 				data[dim.ID+"_NAME"] = (data.ID===-1 && data.NAME==="UNDEFINED" ? VueApp.i18n.translate("undefined") : data.NAME);
        // 				delete data.ID;
        // 				delete data.NAME;
        // 				addAttrName(dim, data, data);
        // 			});
        // 		} else {
        // 			rawdata = [];
        // 		}
        // 		return {field: dim.ID, values: rawdata};
        // 	});
        // }
    }
    function getOldValues(allDims, extraFilters) {
        var columns = [];
        var groupbyColumns = [];
        var op_cols = [];
        var otherFilter = [];
        var drilldownFilter = [];
        var missingDims = calcViewModel.missingDims;
        if (useMeasures) {
            groupbyColumns.push("MEASURE.ID");
            otherFilter.push({ code: "ID", parent: "MEASURE", values: calcViewModel.measures.map(function (m) { return m.ID; }) });
            if (calcViewModel.dateMandatory)
                groupbyColumns.push("FACT.MONTH");
        }
        for (var i = 0; i < calcViewModel.rowDims.length; i++) {
            var dim = calcViewModel.rowDims[i];
            if (dim.code === "DATE") {
                columns.push("FACT.MONTH");
                op_cols.push("FACT_MONTH");
            }
            else {
                columns.push(dim.code + ".ID");
                op_cols.push(dim.code + "_ID");
            }
        }
        var colDim = calcViewModel.colDims[0];
        if (colDim.code === "DATE") {
            groupbyColumns.push("FACT.MONTH");
        }
        else {
            groupbyColumns.push(colDim.code + ".ID");
        }
        for (var i = 0; i < options.filters.length; i++) {
            var filter = options.filters[i];
            var found = false;
            if (extraFilters && extraFilters.length > 0) {
                var _loop_4 = function (j) {
                    var eff = extraFilters[j];
                    if (filter.code === 'ID' && filter.parent === eff.field) {
                        found = true;
                        otherFilter.push({ code: 'ID', parent: eff.field, values: eff.values.map(function (v) { return v[eff.field]; }) });
                        extraFilters.splice(j, 1);
                        return "break";
                    }
                };
                for (var j = 0; j < extraFilters.length; j++) {
                    var state_1 = _loop_4(j);
                    if (state_1 === "break")
                        break;
                }
            }
            if (!found)
                otherFilter.push(filter);
        }
        if (extraFilters && extraFilters.length > 0) {
            var _loop_5 = function (j) {
                var eff = extraFilters[j];
                otherFilter.push({ code: 'ID', parent: eff.field, values: eff.values.map(function (v) { return v[eff.field]; }) });
            };
            for (var j = 0; j < extraFilters.length; j++) {
                _loop_5(j);
            }
        }
        for (var j = 0; j < missingDims.length; j++) {
            otherFilter.push({ code: "ID", parent: missingDims[j].ID, values: [-1] });
        }
        var colStr = columns.join(",");
        var versionList = versions;
        otherFilter.push({ code: "ID", parent: "VERSION", values: versionList.map(function (v) { return v.RESULT_NODE; }) });
        var dateRange = getDateParam(versionList, options.accountTime, (useMeasures && calcViewModel.hasTimeMeasure && calcViewModel.dateMandatory && calcViewModel.type !== 3 ? null : options.dateRange));
        if (!calcViewModel.dateMandatory)
            dateRange.nameSets = options.nameSetSelect;
        var queryObj = {
            sheetId: calcViewModel.id,
            actualAndPlanDataHasOverLap: false,
            selectColumns: colStr,
            groupbyColumns: groupbyColumns,
            orderbyColumns: colStr,
            dateRange: dateRange,
            hasHierarchy: true,
            hierarchyTableName: null,
            hierarchyJoinColumnName: null,
            actualAndPlanDataCutoffDate: null,
            dateField: options.accountTime,
            allDims: allDims,
            relList: calcViewModel.relQueryList,
            drilldownFilter: drilldownFilter,
            dispAttrs: {},
            otherFilter: otherFilter,
            preview: preview,
            versionType: options.versionType
            // accountHierarchy: calcViewModel.accountHierarchy, // get in node.js from sheet definition
            // levelHierarchy: calcViewModel.levelHierarchy
        };
        var dataPromise = null;
        var url = calcViewModel.inputOnly ? "/hdb/mdxGetSheetData" : "/hdb/getFactData";
        queryObj.versionObj = (0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.copyTreeNode)(version);
        dataPromise = $.post({
            url: url,
            data: JSON.stringify(queryObj),
            dataType: "json",
            processData: true,
            contentType: "application/json",
            headers: {
                "Accept": "application/json"
            },
        });
        var compTotalMeasureIDs = new Set();
        if (options.withCompTotal) {
            for (var i = 0; i < calcViewModel.measures.length; i++) {
                var m = calcViewModel.measures[i];
                if (m.RATIO_CALC === 4) {
                    compTotalMeasureIDs.add('' + m.ID);
                }
            }
        }
        var notePromise = Promise.resolve(null);
        if (!preview) {
            queryObj.dateRange = getDateParam(versionList, options.accountTime, options.dateRange);
            var sheetNotePromise = Promise.resolve($.post({
                url: "/hdb/getNotes/SHEET_NOTE",
                data: JSON.stringify(queryObj),
                dataType: "json",
                processData: true,
                contentType: "application/json",
                headers: {
                    "Accept": "application/json"
                },
            }));
            var cellNotePromise = Promise.resolve($.post({
                url: "/hdb/getNotes",
                data: JSON.stringify(queryObj),
                dataType: "json",
                processData: true,
                contentType: "application/json",
                headers: {
                    "Accept": "application/json"
                },
            }));
            notePromise = Promise.all([cellNotePromise, sheetNotePromise]).then(function (_a) {
                var inp1 = _a[0], inp2 = _a[1];
                var input = [].concat(inp2, inp1); //show sheet note first
                if (!input || input.length === 0)
                    return null;
                var root = {};
                var prefix, valueField;
                var colField = calcViewModel.colDims[0].code;
                prefix = colField;
                valueField = (colField === "DATE" ? options.accountTime : colField + "_ID");
                for (var i = 0; i < input.length; i++) {
                    var row = input[i];
                    var current = root;
                    for (var j = 0; j < op_cols.length; j++) {
                        var dim = op_cols[j];
                        if (dim.substring(0, 4) === "FACT")
                            dim = dim.substring(5);
                        var dimValue = row[dim];
                        if (!current[dimValue])
                            current[dimValue] = {};
                        current = current[dimValue];
                    }
                    var dateValue = prefix + "-" + row[valueField];
                    if (row["TIME_COL"] === 'ALL') {
                        dateValue = prefix + "-ALL";
                    }
                    else if (useMeasures && calcViewModel.measures.length > 1) {
                        var mID = row["MEASURE_ID"];
                        if (options.withCompTotal) {
                            if (compTotalMeasureIDs.has('' + mID))
                                continue;
                        }
                        else {
                            dateValue = dateValue + "-m" + mID;
                        }
                    }
                    current[dateValue] = [{ content: row["CELL_NOTE"], userName: row["USER_NAME"], userId: row["USER_ID"] }];
                }
                console.log(JSON.stringify(root));
                return root;
            }).catch(function (reason) {
                console.error(reason);
                return null;
            });
        }
        var dataLockPromise = Promise.resolve(null);
        if (enableDatalock)
            dataLockPromise = Promise.resolve($.post({
                url: "/hdb/getDataLock",
                data: JSON.stringify(queryObj),
                processData: true,
                contentType: "application/json",
                headers: {
                    "Accept": "application/json"
                },
            }).then(function (data) {
                if (!data || !data.records)
                    return {};
                var input = data.records;
                var root = {};
                var prefix, valueField;
                var colField = calcViewModel.colDims[0].code;
                prefix = colField;
                valueField = (colField === "DATE" ? "TIME_ID" : colField + "_ID");
                for (var i = 0; i < input.length; i++) {
                    var row = input[i];
                    var current = root;
                    for (var j = 0; j < op_cols.length; j++) {
                        var dim = op_cols[j];
                        if (dim.substring(0, 4) === "FACT")
                            dim = dim.substring(5);
                        var dimValue = row[dim];
                        if (!current[dimValue])
                            current[dimValue] = {};
                        current = current[dimValue];
                    }
                    var dateValue = prefix + "-" + row[valueField];
                    if (useMeasures) {
                        if (options.withCompTotal) {
                            if (!compTotalMeasureIDs.has('' + row.MEASURE_ID))
                                current[dateValue] = row.STATUS;
                        }
                        else {
                            if (!current[dateValue])
                                current[dateValue] = {};
                            current[dateValue][row.MEASURE_ID] = row.STATUS;
                        }
                    }
                    else
                        current[dateValue] = row.STATUS;
                }
                //console.log(JSON.stringify(root));
                return root;
            }));
        var formularPromise = preview ? Promise.resolve(null) : $.getJSON("/hdb/getSheetFormular/" + calcViewModel.id);
        var processFactData = function (input) {
            var prefix = "ACCOUNT-";
            var result = {};
            var colDim = calcViewModel.distDimension;
            var colID = colDim + "_ID";
            for (var i = 0; i < input.length; i++) {
                var data = input[i];
                var colVal = data[colID];
                var entry = result[colVal];
                if (!entry) {
                    entry = {};
                    result[colVal] = entry;
                }
                var acctVal = data["ACCOUNT_ID"];
                var msVal = data["MEASURE_ID"];
                var propVal = prefix + acctVal + "-m" + msVal;
                entry[propVal] = data["AMOUNT"];
            }
            return result;
        };
        var valuePromise = dataPromise.then(function (input) {
            if (calcViewModel.type === 3)
                return { root: processFactData(input) };
            var root = {};
            var valueList = [];
            var dateFieldList = null;
            var offset = (useMeasures ? (calcViewModel.dateMandatory ? 3 : 2) : 1);
            var dims = [];
            var fieldNames = [];
            var fieldTexts = [];
            var isTimeRow = [];
            var childNums = [];
            for (var j = 0; j < op_cols.length; j++) {
                var dim = input.axisinfo[j + offset].DIMENSION;
                dims.push(dim.toUpperCase());
                var dimHierarchy = getDimHierarchy(dim, calcViewModel);
                fieldNames.push("[".concat(dim, "].[").concat(dimHierarchy, "].[MEMBER_UNIQUE_NAME]"));
                fieldTexts.push("[".concat(dim, "].[").concat(dimHierarchy, "].[MEMBER_CAPTION]"));
                isTimeRow.push((dim === "Time"));
                childNums.push("[".concat(dim, "].[").concat(dimHierarchy, "].[CHILDREN_CARDINALITY]"));
            }
            var timeCoordinates = input.axisinfo[0].COORDINATES;
            var cellIdx = 0;
            var cells = input.cell;
            var timeAxis = input.axis0;
            var timeDim = input.axisinfo[offset - 1].DIMENSION; //not always time 
            var timeDimHierarchy = getDimHierarchy(timeDim, calcViewModel);
            var isTimeCol = (timeDim === "Time");
            var timeDimCode = (isTimeCol ? "DATE" : timeDim.toUpperCase());
            var timeCardinality = "[".concat(timeDim, "].[").concat(timeDimHierarchy, "].[CHILDREN_CARDINALITY]");
            var timeLevelNum = "[".concat(timeDim, "].[").concat(timeDimHierarchy, "].[LEVEL_NUMBER]");
            var timeMember = "[".concat(timeDim, "].[").concat(timeDimHierarchy, "].[MEMBER_UNIQUE_NAME]");
            var timeText = "[".concat(timeDim, "].[").concat(timeDimHierarchy, "].[MEMBER_CAPTION]");
            var compTotalMeasures = new Set();
            if (options.withCompTotal) {
                for (var i = 0; i < calcViewModel.measures.length; i++) {
                    var m = calcViewModel.measures[i];
                    var mdxVal = "[Measure].[Measure].&[".concat(m.ID, "]");
                    if (m.RATIO_CALC === 4)
                        compTotalMeasures.add(mdxVal);
                }
            }
            if (isTimeCol) {
                dateFieldList = [];
                for (var i = 0; i < timeAxis.length; i++) {
                    if (options.withCompTotal && compTotalMeasures.has(timeAxis[i]["[Measure].[Measure].[MEMBER_UNIQUE_NAME]"]))
                        continue;
                    dateFieldList.push({ value: timeAxis[i]["[Time].[Time].[MEMBER_CAPTION]"], level: timeAxis[i][timeLevelNum] });
                }
            }
            var df = (0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.getTimeLevel)(options.accountTime);
            var measureRe = /\[.*\]\.\[.*\]\.(\&\[(-?\d*)\])|(\[BALANCE_(\d*)\])/;
            for (var i = 0; i < input.axis1.length; i++) {
                var axisVal = input.axis1[i];
                var current = root;
                var dimValue = void 0, dimName = void 0;
                var valueNode = {}, leaf = true, childNum = 0;
                for (var j = 0; j < fieldNames.length; j++) {
                    if (isTimeRow[j]) {
                        dimValue = axisVal["[Time].[Time].[MEMBER_CAPTION]"];
                        dimName = (0,_ts_tsutils__WEBPACK_IMPORTED_MODULE_1__.formatDate)(dimValue, df);
                    }
                    else {
                        var fn = fieldNames[j];
                        var fv = axisVal[fn];
                        dimValue = mdxRetrieveValue(fv);
                        dimName = axisVal[fieldTexts[j]];
                    }
                    if (dimValue) {
                        if (calcViewModel.inputOnly && calcViewModel.rowInput) {
                            childNum = axisVal[childNums[j]];
                            if (childNum > 0) {
                                leaf = false;
                                break;
                            }
                            var dimCode = (isTimeRow[j] ? "DATE" : dims[j]);
                            valueNode[dimCode] = dimValue;
                            valueNode[dimCode + "_NAME"] = (dimValue === "-1" && dimName === "UNDEFINED" ? VueApp.i18n.translate("undefined") : dimName);
                        }
                        else {
                            if (!current[dimValue])
                                current[dimValue] = {};
                            current = current[dimValue];
                        }
                    }
                    else
                        break;
                }
                if (calcViewModel.inputOnly && calcViewModel.rowInput && leaf)
                    valueList.push(valueNode);
                var upperOrdinal = (axisVal.TUPLE_ORDINAL + 1) * timeCoordinates;
                var timeIdx = void 0, timeCell = void 0, dateValue = void 0, ordinal = void 0, versionValue = void 0;
                for (; cellIdx < cells.length && (ordinal = cells[cellIdx].ORDINAL) < upperOrdinal; cellIdx++) {
                    timeIdx = ordinal % timeCoordinates;
                    timeCell = timeAxis[timeIdx];
                    if (useMeasures && calcViewModel.dateMandatory) {
                        dateValue = timeCell["[Time].[Time].[MEMBER_CAPTION]"];
                        if (dateValue !== options.dateRange.values[0])
                            continue;
                    }
                    //if(timeCell[timeCardinality]===0 || 
                    //   	timeCell[timeLevelNum]===1) {
                    if (isTimeCol)
                        dateValue = timeCell["[Time].[Time].[MEMBER_CAPTION]"];
                    else {
                        var rawValue = timeCell[timeMember];
                        dateValue = mdxRetrieveValue(rawValue);
                    }
                    if (!dateValue)
                        continue;
                    if (calcViewModel.inputOnly && calcViewModel.rowInput) {
                        if (leaf) {
                            var propVal = timeDimCode + "-" + dateValue;
                            if (useMeasures && calcViewModel.measures.length > 1) {
                                var measureVal = timeCell['[Measure].[Measure].[MEMBER_UNIQUE_NAME]'];
                                var match = measureRe.exec(measureVal);
                                if (match) {
                                    if (match[2])
                                        propVal = propVal + "-m" + match[2];
                                    else if (match[4]) {
                                        propVal = propVal + "-mb" + match[4];
                                    }
                                }
                            }
                            valueNode[propVal] = cells[cellIdx].FORMATTED_VALUE;
                        }
                    }
                    else {
                        var propVal = dateValue;
                        if (!options.withCompTotal) {
                            if (useMeasures && calcViewModel.measures.length > 1) {
                                var measureVal = timeCell['[Measure].[Measure].[MEMBER_UNIQUE_NAME]'];
                                var match = measureRe.exec(measureVal);
                                if (match) {
                                    if (match[2])
                                        propVal = propVal + "-m" + match[2];
                                    else if (match[4]) {
                                        propVal = propVal + "-mb" + match[4];
                                    }
                                }
                            }
                            current[propVal] = cells[cellIdx].FORMATTED_VALUE;
                        }
                        else {
                            var measureVal = timeCell['[Measure].[Measure].[MEMBER_UNIQUE_NAME]'];
                            if (!compTotalMeasures.has(measureVal)) {
                                current[propVal] = cells[cellIdx].FORMATTED_VALUE;
                            }
                            else {
                                var match = measureRe.exec(measureVal);
                                if (match) {
                                    if (match[2])
                                        propVal = "m" + match[2];
                                    current[propVal] = cells[cellIdx].FORMATTED_VALUE;
                                }
                            }
                        }
                    }
                }
            }
            if (calcViewModel.inputOnly && calcViewModel.rowInput)
                return { root: valueList, dateFieldList: dateFieldList };
            else
                return { root: root, dateFieldList: dateFieldList };
        });
        return Promise.all([valuePromise, notePromise, formularPromise, dataLockPromise]).then(function (_a) {
            var _b = _a[0], root = _b.root, dateFieldList = _b.dateFieldList, noteRoot = _a[1], formularList = _a[2], dataLockRoot = _a[3];
            return { value: root, note: noteRoot, dataLock: dataLockRoot, formularList: formularList, dateFieldList: dateFieldList };
        });
    }
}



/***/ })

}]);
//# sourceMappingURL=ts_runtime_ts.build.js.map